#include <stdio.h>
#include <math.h>
#include "pv.h"
 
int smoothspec( float *F, int N2, float octaves,  int R )
{


// AVERAGE THE SPECTRUM VALUES WITH WINDOWS THE SIZE OF
// octaves

    static float fund, *T ; 
    static int first=1 ; 

    int  i, j, k,  l, m,   lowbin,  hibin ;
    float pma, t,  pmb,   norm,  temp,  temp2,  peakampF,  peakampT ;


  if( octaves <= 0.){
      return(0) ; 
  }else{
    //fprintf( stderr, "\n\n.......SMOOTHING  THE PEAK SPECTRUM..." ) ; 

    // FIND PEAK AMP
    peakampF = -99999999. ; 
    for(j = 0,  i = 0; j < N2; j++,  i += 2) 
	if( F[i] > peakampF ) peakampF = F[i] ; 
    
    
    if( first == 1 ) {
	fvec(T, N2) ; // TEMP SPACE
	fund = (float) R / (float) (N2 * 2) ; 
	first = 0 ; 
    }
    
    // OCTAVES TO MULTIPLIER
    t = octaves / 2. ; 
    pma = pow( (double) 2.,  (double) t ) ; 
    pmb = pow( (double) 2.,  (double) (-t) ) ; 
    
	// LOOP FOR BINS
    for(i = 1,  j = 0; j < N2; i += 2,  j++ ){

	lowbin = (int) (.5 + (pmb * j)) ;
	hibin = (int) (.5 + (pma * j)) ;
	if(lowbin < 0)lowbin = 0;
	if(hibin > N2 )hibin = N2;
	if( hibin == lowbin )hibin = lowbin + 1 ; 

	T[j] = 0; temp = 0 ; 
	for(k = lowbin,  m = 0; k < hibin; k++,  m++){
	    T[j] +=  F[ k*2 ] ; 
//	    if(F[ k*2 ] > T[j]) T[j] = F[ k*2 ] ; 
	
	}	
	T[j] = T[j] / (float) m ; 

    }
    

    // FIND PEAK AMP IN T
    peakampT = -99999999. ; 
    for(j = 0,  i = 0; j < N2; j++,  i += 2) 
	if( T[j] > peakampT ) peakampT = T[j] ; 

    if( peakampT > 0. ) norm = peakampF / peakampT ; 
    else norm = 1. ; 
    
    // REPLACE VALUES IN F
    for(j = 0,  i = 0; j < N2; j++,  i += 2) F[i] = T[j] * norm ; 


    return( 1 ) ; 
  }
}
