#include "pv.h"
#include <math.h>

/*
 * PRINT THE INPUT ARRAY OF FREQUENCIES AND MAGNITUDES
 * WITH A PLOT ON THE SIDE -- OLD WORLD STYLE
 */
int tprintspec( float *F, int N, float fundamental, int freqcutoff ){

    int i, j, k, ii, jj,  flag,  zeroflag,  itemp ; 
    float temp,  temp2, temp3, dBnow,  basedB,  peakdB,  dBrange,  dBdiv ; 
 
    float A[10], AdB[10], freq ; 
    int lowbin,  highbin,  n,  ibin ; 

    // OCTAVE AVERAGE PRINT
    freq = 31.25 ; n = 0 ; 

    for( i = 0; i < 10; i++) {
	A[ i ] = 0. ;
	lowbin =  (int) (freq / fundamental) ; 
	highbin = 1 + (int) (2. * freq / fundamental) ; 
	if( highbin > (N / 2) ) highbin = N / 2 ; 
	n = 0 ; 
	for( j = lowbin; j < highbin; j++){
	    A[ i ] += F[ j * 2 ] ; n++ ; 
	}
	if( n != 0 ) A[ i ] = A[ i ] / (float) n ; 
	if( A[ i ] > 0. ) AdB[ i ] = 20. * log10( A[ i ] ) ; 
	freq *= 2. ; 
    }
    


	zeroflag = 0 ; 
	basedB = 99999999999. ; flag = 0 ; peakdB = -99999999999. ; 



	for( i = 1; i < N; i += 2){ 
	    if( F[i - 1] > 0.){
		dBnow = (20. * log10( (double) F[ i - 1 ] )) ; 
		if( dBnow < basedB ) {basedB = dBnow ; flag = 1;}
		if( dBnow > peakdB ) {
		     peakdB = dBnow ;
		}
		
	    }
	}
	if( flag == 0 )prt( "\nALL ZERO AMPLITUDES!\n" ) ; 
	
	dBrange = peakdB - basedB ; 
	dBdiv = dBrange / 32. ; 
	if(dBdiv < 1.)dBdiv = 1. ; 

    prbanner(  "FFT DATA (FREQUENCY/AMPLITUDES)",  69 ) ; 
 
    prline( 69,  "=" ) ;
    prt( "| BIN |BINFREQ|FREQ   |AMP     |DB  | DECIBELS GRAPH                |" ) ; 
    prline( 69,  "=" ) ;




	basedB *= -1. ; 
	    for( i = (N-1),  j = ((N/2)-1); i >= 0 ; i -= 2,  j--){ 
		itemp = (int) ((float) j) * fundamental ; 
	      if( 
		    ((F[ i - 1 ] > 0.) || (zeroflag)) && 
		    ((itemp < (float) freqcutoff) || (freqcutoff == 1)) ){
		zeroflag = 1 ; 
		fprintf( stderr,  "\n%5d| %-7.1f|%-7.1f|%-8.6f|",
			j, ((float) j) * fundamental,   F[ i ],  F[ i - 1 ] ) ;

	       if( flag ){
		 if( F[i - 1] > 0.){
		     dBnow = (20. * log10( (double) F[ i - 1 ] )) ; 
		     if( dBnow != 0.)fprintf( stderr,  "%-4.f|",  dBnow ) ; 
		     else fprintf( stderr,  "-0  |" ) ;

		    // GRAPH
		    k = (int) (.5 + ((basedB + dBnow) / dBdiv)) ;  
		    if( dBnow >= peakdB ){
			fprintf( stderr, "-> PEAK <" ) ;
			k -= 9 ; 
			for(jj = 0; jj < k; jj++)fprintf( stderr, "-" ) ;
			    fprintf( stderr, "+" ) ;
		    }else{
			for(jj = 0; jj < k; jj++)fprintf( stderr, "-" ) ;
			    fprintf( stderr, "+" ) ;
		    }
		}else{
		    // O AMP
		    fprintf( stderr,  "    |o" ) ; 		    
		}

	      }
		
	    }

	    }
    prline( 69,  "=" ) ;
    prt( "| BIN |BINFREQ|FREQ   |AMP     |DB  | DECIBELS GRAPH                |" ) ; 
    prline( 69,  "=" ) ;

    prline( 69,  "=" ) ;
    fprintf( stderr, "\nAVERAGE RESPONSE BY OCTAVE" ) ; 
    fprintf( stderr, "\n\ndB " ) ; 
    for( k = 0 ; k < 10; k++ ){ 
	fprintf( stderr, "| " ) ;   
	if( A[ k ] > 0. )
	    fprintf( stderr, "%-4.f ",   AdB[ k ] ) ;  
	else
	    fprintf( stderr, "  -o- " ) ; 

    }
    fprintf( stderr, "| " ) ;   
    prline( 69,  "-" ) ;

    fprintf( stderr, "\nHz:31     62    125    250    500   1000   2000   4000   8000   16000  22050" ) ; 
    
    prline( 69,  "=" ) ;

    return(1); 

}
