#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "globals.h"

#define BLOCKSIZE 1024

/*
* THIS ROUTINE READS THE SHORTS OF THE SPECIFIED FILE AND 
* CHANNEL AND WRITES THEM AS FLOATS TO THE STANDARD OUT
*
*/

/* CRACK STUFF */
extern int arg_index;
extern char *arg_option;
extern int bannerflag;


/************************************************************/

int main(argc,argv)
   int argc;
   char *argv[]; 
   {
   


    char	*filename, 
		ch, 
		crack()
    ;

    int		pflag=0, 
		outputswitch=1, 
		i, 
		n, 
		doneflag=0, 
		numsamps,
		numbytes,  
		exflag, 
		sr,
		chan,
		data_offset, 
		format, 
		fd,
		end_sample, 
		begin_sample, 
		sample, 
		outchan, 
		new_blocksize=BLOCKSIZE, 
		pt
    ;
	
    short int	idata[ BLOCKSIZE * 4 ] 
    ; 
		
    float	outarray[ BLOCKSIZE ],
		peakamp=0.,
		peakdB,
		rms=0., 
		rmsdB,   
		c,
		avgamp=0.,
		avgdB,   
		dur, 
		out, 
		begin, 
		end,
		temp
    ;

	FILE *data_file ;

/*GIVE USAGE AND EXIT IF NO ARGUMENTS */
   if(argc == 1) {
	fprintf( stderr,"%s",
	"USAGE:\n\n   flout [ flags ] [ NeXT/Sun format input soundfile (shorts)]\n" 
	"\tflags:\n"
	"	(values in brackets denote defaults)\n"
	"   :c	    output channel: 0-? [0]\n"
	"   :b	    start time in seconds  [0.]\n"
	"   :e	    end time in seconds  [end of file]\n"
	"   :p	    add -p for time and amplitude  statistics [no statistics]\n"
	"   :o	    add -o to turn output off [on]\n\n"
	"   This routine reads shorts from the specified channel of the\n"
	"   NeXT/Sun format input soundfile for the values between\n"
	"   begin and end and writes them to the standard out as floats.\n\n" 
	 );
	exit(0);
    }
   
   begin = 0. ; end = -1. ; outchan = 0 ; 
    while((ch = crack(argc,argv,"c|b|e|po",0)) != 0)
{
        switch(ch) {
            case 'c': outchan = atoi(arg_option) ;                  break;
            case 'b': begin = atof(arg_option) ;                  break;
            case 'e': end = atof(arg_option) ;                  break;
            case 'p': pflag = 1 ;                  break;
            case 'o': outputswitch = 0 ;                  break;

        }
    }

    if( arg_index >= argc ){
	    banner() ;
	fprintf( stderr, "\n\nWHERE IS THE FILE? BYE.\n\n") ;
        exit(0)  ;	
    }


/* GET SOUNDFILE NAME AND OPEN FOR BUSINESS */
   filename = argv[arg_index] ;

        exflag = getsfstats(filename, &sr, &chan, &dur, \
                &data_offset, &format);
	

	if ( exflag == -2 ) {
	    banner() ;
	    fprintf( stderr, "\n\n\t....FIX THE FORMAT OF YOUR FILE. BYE.\n\n" ) ;
	    exit(0) ; 
	}
	if( exflag == -1 ) {
	    banner() ;
	    fprintf( stderr, "\n\n\t....FIX YOUR FILE (PATH)NAME. BYE.\n\n" ) ;
	    exit(0) ; 
	}


	begin_sample = begin * (float) sr ; 

/*		 
     //   fprintf(stderr,  "%s has sr=%d, chan=%d, dur=%f, data_offset=%d, format=%d\n", \
     //            filename, sr, chan, dur, data_offset, \
     //            format);
*/

	if( exflag  == -1 ) 

/* CHECK FOR STUPIDITY */
    if( format != 3 ){
	    banner() ;
        fprintf( stderr, "\n\nYOUR FILE IS NOT A NEXT FORMAT FILE.\n\n" ) ;
        exit(0)  ;
    }

    if( begin < 0. ){
	fprintf( stderr,
	     "\n\nBEGIN TIME (%f) is < 0. (GET REAL!)\nWILL RESET TO 0.\n\n",  begin  ) ;
	     begin = 0. ; 
    }

	
    if( (end != -1.) && (end <= begin)){


	    banner() ;
	fprintf( stderr,
	     "\n\nBEGIN TIME = %f\nEND TIME = %f\n\n",  begin,  end  ) ;

	fprintf( stderr,
	     "\n\nYOUR END TIME IS BEFORE OR EQUAL TO YOUR BEGIN TIME! BYE.\n\n" ) ;
	exit(0) ; 
    }
	
    if( end > dur ){
	    banner() ;
	    fprintf( stderr, "%s%f%s%f%s", "\nYOUR END TIME OF  ", 
		end, 
		"  SECONDS \nEXCEEDS THE FILE DURATION OF  ", 
		dur, 
		" SECONDS.\nWILL RESET TO THE DURATION OF THE FILE.\n\n" 
		 ) ;
	   	
    }

  
/* NO END TIME SPECIFIED, SET TO dur */
    if( end <= 0. ) end = dur ; 
    end_sample = (int) (end * (float) sr ) ; 
/*
        fprintf(stderr,  "%s has sr=%d, chan=%d, dur=%f, data_offset=%d, format=%d\n\n", \
                 filename, sr, chan, dur, data_offset, \
                 format);
*/
 
    if( outchan >= chan ){
	banner(); 
        fprintf( stderr, "\n\nTHE AVAILABLE CHANNELS ARE 0-%d, NOT %d. BYE.\n\n",\
	     (chan-1), outchan ) ;
        exit(0)  ;
   }

    data_file = fopen( filename,  "r" ) ; 

/* SKIP TO DATA OFFSET + BEGIN */
	
	fseek( data_file, data_offset + (2 * begin_sample * chan), SEEK_SET ) ;
	
/* READ IN THE VALUES */


	c = 0 ;  sample = begin_sample ; 

	new_blocksize = chan * ((int) (new_blocksize / chan)) ; 
	
	/* fprintf( stderr, "\n new_blocksize = %d",  new_blocksize ) ; */ 

	numsamps = fread( &idata, sizeof(short int), new_blocksize,  data_file ) ; 
	numsamps = numsamps / chan ; 
	
	while( (doneflag != 1 ) && ( numsamps > 0 ) ) {

	    if( (end_sample - sample) < numsamps ){
		numsamps = (end_sample - sample) ;
		doneflag = 1 ;  
	    }
	    
	    for( i = 0; i < numsamps; i++ ){
		outarray[ i ] = ((float) idata[ (i * chan) + outchan ]) / 32768.0 ; 
		temp = fabs( outarray[ i ] ) ; 
		if( temp > peakamp ){
		     peakamp = temp ; pt = c ; 
		} 
		avgamp += temp ;
		c += 1. ; 
		
		// RMS
		rms = rms + (outarray[ i ] * outarray[ i ] ) ; 



	    }
	    
	    if( outputswitch == 1 )fwrite( &outarray, sizeof(float), numsamps,  stdout ) ;
	    
	    sample += numsamps ; 

	numsamps = fread( &idata, sizeof(short int), new_blocksize,  data_file ) ; 
	numsamps = numsamps / chan ; 
	
	}

	fclose( data_file ) ; 

	if( pflag != 0  ){

	    peakdB = (float) (20. * log10( (double) peakamp )) ; 
	    fprintf( stderr, "\n\nPEAKAMP:\t%8.5f\t(%6.2f dB)\tAT %f seconds",
		 peakamp,  peakdB,  (float) pt / (float) sr ) ;

	    avgamp = avgamp /  c ;
	    avgdB = (float) (20. * log10( (double) avgamp )) ; 
    	    fprintf( stderr, "\nAVERAGE AMP:\t%8.5f\t(%6.2f dB)\n",  avgamp,  avgdB ) ;


	    rms = (float) pow( (double) (rms / c),  .5 ) ; 
	    rmsdB = (float) (20. * log10( (double) rms )) ; 
    	    fprintf( stderr, "\nRMS AMP:\t%8.5f\t(%6.2f dB)\n\n",  rms,  rmsdB ) ;
	}

}


int banner(){
    if( bannerflag == 0 )
    fprintf( stderr,  "\n\n*************************************\n*********     FLOUT     **********\n*************************************\n" ) ;
			 bannerflag = 1 ; 
}	
