#include "globals.h"

main( argc, argv )
    int argc ; char *argv[] ;
{
int nn,  sec,  min ; 
float oldt ; 
int i,j, k, jj, ii,   exflag;
float nyquist,   fundamental ;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag = 0,  channelout=0 ;
float P = 1.0;
FILE *fopen(), *fp,  *adata;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *F,  *SP ; 
float	gain=1. ;
float  temp,  temp2,  temp3,  temp4,  temp5,  temp6  ;
float getthresh();
float peakbinamp = 0.,  avgbinamp=0.,  peakamp,  dur ;

char asciispectfile[128]="ascii_spectrum" ;
int  asciiflag=0 ; 

int weightflag=0 ; 
int   print_flag=0, buffer_count=0 ; 
float   IR, DR,  n=2048 ;
char tempstring[ 128 ] ; 

// SHELF EQ
float  dBlow=0, dBhi=0,  freqlow=200, freqhi=2000  ; 
int eqnormbypassflag=0 ; 

int method_flag=0 ; 
int beginchan,  endchan ; 

float totalframesum=0.,  framesum ; 

#include "underflow.h"

if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|a|M|P|D|t|C|b|e|B|W|I|H|m|f|c|l|d|s|X|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'N':   N = atoi(arg_option);
			break;
	    case 'M':   Nw = atoi(arg_option);
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;

	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;

	    case 'a':   strcpy(asciispectfile, arg_option); asciiflag=1 ; 
			break;



	    case 'H':   dBlow = atof(arg_option) ;
			break;
	    case 'X':   dBhi = atof(arg_option) ;
			break;
	    case 'm':   freqlow = atof(arg_option) ;
			break;
	    case 'R':   freqhi = atof(arg_option) ;
			break;

	    case 'B':   eqnormbypassflag = atoi(arg_option) ; 
			break;
	    case 'W':   weightflag = atoi(arg_option) ; 
			break;

	    case 'c':   method_flag = atoi(arg_option) ;
			break;
	    case 'P':   print_flag = atoi(arg_option) ;
			break;
	    case 'h':	usage(1);
	}
    }
prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "FREQRESPONSE", 69 ) ; 
prline( 69,  "-" ) ; 


    if(channelout == 0){
	channelflag = 0 ; 
	beginchan = 0 ;
    } else{
	channelflag = 1 ; 
	beginchan = channelout - 1 ; 
    }
    // SET NO OUTPUT FLAG
    outputoff=1;

// GET INPUT HEADER INFO
    setupfiles(argc, argv) ; 

    endchan = beginchan + ochan ; 

// GET NAME OF OUTPUT FILE
    arg_index++ ; 

    if( arg_index >= argc  ){
	bannero() ;
	ofile =  "pv.freqresponse" ; 
	fprintf( stderr, "\n\n......USING DEFAULT OUTPUT FILENAME........\n\n" ) ;
    }else{
/* GET OUTPUT FILE NAME */
   ofile = argv[arg_index] ; 
    }	 
    /* OPEN FOR BUSINESS */
    

    ofd = open(ofile,O_RDWR,(0644));
    if(ofd < 0) {
	fprintf( stderr,  "\n\n%s DOES NOT YET EXIST. I'LL MAKE IT.\n", ofile );
	exflag = open(ofile, O_CREAT,(0644)); 
	if( exflag == -1 ){
	    bannero() ;
	    fprintf( stderr,  "\n\n I COULD NOT MAKE THE FILE:\n\n-----> %s <-------\n\n",  ofile ) ; 
	    fprintf( stderr,  "\n\n CHECK THE PATH OF YOUR FILE. ....BYE.\n\n" ) ; 
		exit( 0 ) ; 
	}
	ofd = open(ofile, O_RDWR,(0644));
    }else{
	open(ofile, O_TRUNC, (0644));
    }


     
// **** SET UPS *****
    R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    D = (int) ((float) R / frames_per_sec) ; 
//*****
//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
//*********************************


    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    fundamental =  ((float) R / (float) N) ; 
    obank = P != 0. ;
    if( P == 0.0 ) {P = 1.0;}
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    DR = (float) D / (float) R ; 
    // COMPUTE THE DURATION
    dur = (endt - begint) ; 

    
//***************** PRINT VALUES
prf( dur, "OUTPUT FILE: DURATION" ) ; 

prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 

pri( frames_per_sec,  "FRAMES/SECOND" ) ; 
prline( 1,  "*" ) ; 
pri( D,  "      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
prline( 1,  "*" ) ; 
prt( "*............. LOW/HIGH SHELF EQ............*" ) ;  
prf( freqlow, "LOW SHELF FREQUENCY" ) ; 
prf( dBlow, ".......... LOW SHELF DECIBELS" ) ; 
prf( freqhi, "HIGH SHELF FREQUENCY" ) ; 
prf( dBhi, ".......... HIGH SHELF DECIBELS" ) ; 
if(eqnormbypassflag == 0)prt( "NORMALIZATION: ON" ) ; 
    else prt( "NORMALIZATION: OFF" ) ;
prt( "*...........................................*" ) ;  
if(method_flag == 0)prt( "METHOD: AVERAGING" ) ; 
    else prt( "METHOD: PEAKS" ) ;


// *******

    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */

// MAKE SPECTRUM AVERAGE ARRAY
    fvec( SP, N+2 ) ;	/* spectrum average or peak array */
    for(i = 0; i < (N+2); i++ ) SP[ i ] = 0. ; 


// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 



//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(outchan = beginchan,  channow = 0; outchan < endchan; outchan++,  channow++ ){

prline( 69,   "=" ) ; 
pri( (outchan+1), "ANALYSIS: CHANNEL" ) ; 

    //*****   REINITS
    frame_count = 0 ;    eof = 0 ; 



    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;


	oldt = 0. ; 
	sec = 0 ;
	min = 0 ;  
	nn = 0 ;
	samps = 0 ;   
	
//*********************************************
// LOOP FOR FRAMES
//*********************************************

    while ( !eof ) {
	in += D ;
	on += I ;
	timenow( dur ) ;

	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;
	  	  convert( buffer, channel, N2, D, R ) ;


	// PASSIFIER PRINT
	if( (t - oldt) > .25 ){
	    // PRINT 
	    if( nn == 0 ){

		if( sec == 0 ){
		    // PRINT MINUTE
		    if( min != 0 ) {
			if( min == 1) fprintf( stderr, "\n\n ---------> %d minute ......................\n\n", min ) ;
			else fprintf( stderr, "\n\n ---------> %d minutes ......................\n\n", min ) ;
		    }else{
			fprintf( stderr, "\n\n" ) ; 
		    
		    } 
		    min++ ; 
		}
		
		// PRINT SECONDS
		
		    fprintf( stderr, " %d ",  sec ) ; 
		    sec++ ; if( sec >= 60 ) sec -= 60 ; 
		
	    }else{
		// PRINT QUARTER SECOND STARS
		fprintf( stderr, "*" ) ; 
	    }
	    // UPDATE TIME
	    oldt = oldt + .25 ;
	      
	    nn++ ; if( nn >= 4 ) nn -= 4 ;  

	}

	samps += D ; 


//*****************
// MODIFICATIONS LOOP
//*****************
		// FIND FRAME SUM
		if( weightflag == 0 ){
		    framesum = 0. ; 
		    for( i = 0; i < N; i+= 2) framesum += channel[i]  ; 
		}

		 for( i = 1; i < N; i+= 2){
 		    
		    if( method_flag == 1){

		    // PEAK METHOD
			if(channel[i - 1] > SP[ i - 1 ])SP[ i - 1 ] = channel[i - 1] ;

		    } else{

		    // AVERAGE METHOD
			if( weightflag == 0 ){
			    // WEIGHTED MODE
			    SP[ i - 1 ] = SP[ i - 1 ]  + (framesum * channel[i - 1]) ;
			}else{
			    // NON-WEIGHTED MODE
			    
			    SP[ i - 1 ] = SP[ i - 1 ]  + channel[i - 1] ;
			}


		    } 
// COLLECT FREQ STATS		
		    SP[ i ] += channel[ i ] ;	
		}

	totalframesum += framesum ; 
	frame_count++ ; 
	buffer_count++ ;

// FRAMES LOOP END
    }

// CHANNELS LOOP END
} 

    // CLOSE  INPUT FILE
    fclose(ifd) ;  

// TAKE AVERAGE NOW IF AVERAGE METHOD
    temp = (float) buffer_count ; 
    if( method_flag == 0){
	for( i = 1; i < N; i+= 2){
	    
	    if( weightflag == 0 ){
		    // WEIGHTED MODE
		SP[i - 1] = SP[i - 1] / totalframesum ;
	    }else{
		    // NON-WEIGHTED MODE
		SP[i - 1] = SP[i - 1] / temp ;
	    }

	}	
    
    }
// TAKE AVERAGE FREQ
	for( i = 1; i < N; i+= 2){
	    SP[ i ] = SP[ i ] / temp ;
	}	



// IF FLAG OFF, EQUALIZE AND NORMALIZE THE OUPUT SPECTRUM
if( eqnormbypassflag == 0 )
    eq( SP,  N,  dBlow,  dBhi, freqlow,  freqhi,  fundamental,
	1, 0, 1 ) ; 


// WRITE RESPONSE TO file
    for( i = 0; i < N; i++ )write(ofd,  &SP[ i ], sizeof(float) ) ;

    close(ofd) ; 

    // WRITE RESPONSE TO ASCII SPECTRUM FILE
    if( asciiflag ){
	 adata  = fopen( asciispectfile,  "w") ;
        for( i = 0; i < N; i += 2 )
	    fprintf( adata, "%f %f\n",  
		fundamental * (float) (i/2), amp_to_dB( SP[ i ] ) ) ;
	fclose( adata ) ; 
    }


    if( print_flag )tprintspec( SP, N, fundamental,  print_flag) ;


fprintf( stderr,  "\n\nNUMBER OF ANALYSIS OUTPUT AMP/FREQ PAIRS:    %d\n",  N/2 ) ; 
    
fprintf(stderr,"\n\nFREQ RESPONSE : ANALYSIS COMPLETED\n\n");
    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"freqresponse:  analysis-driven, frequency response maker \n"
	"freqresponse   [flags] [input file (16-bit shorts)] [output freqresponse file (optional)]\n"
	"	N:	FFT length (must be a power of 2) [1024]\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	D:	analysis frames per second [200]\n"

	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (-1. = end of file) [0.] \n"
	"	C:	analysis channel(s) (1 -> ?) (0 = all) [0] \n"
	"		    (more than one channel will be averaged)\n"

	
	"	c:	0 = average spectrum, 1 = peak spectrum [0] \n"
	"	W:	average amplitude weighting: 0 = off,  1 = on [0] \n"
	"		    (In average mode (-c0),  the average is weighted by the frame's\n"
	"			sum,  causing the average to reflect the louder frames.)\n"
	"	B:	EQ/normalization bypass (1 = bypass, 0 = no bypass) [0] \n"
	"	H:	SHELF EQ: Low shelf gain in dB [0.] \n"
	"	X:	SHELF EQ: High shelf gain in dB [0.] \n"
	"	m:	SHELF EQ: Low shelf frequency in Hz [200.] \n"
	"	R:	SHELF EQ: High shelf frequency in Hz [2000.] \n"

	"	a:	ASCII spectrum file (frequency/amplitude(dB) pairs,  one per line)\n"
	"	P:	FREQUENCY RESPONSE PRINTOUT: high cutoff frequency in Hz [0.]\n"
        "	            (0. = off)\n"

	);
    exit(woof);
}


int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

