#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef __sgi
#include <sys/fpu.h>
#endif
#include <time.h>
#include "../PVC_LIB/pv.h"

#define FFT_HEADER_SIZE 32

// GLOBALS
complex zero = { 0., 0. } ;
complex one = { 1., 0. } ;
float PI ;
float TWOPI ;
float synt ;

// FILE I/O 
char	    *ifile ; 
char	    *ofile ; 
FILE	    *ifd;
int	    ofd;
#ifdef USE_SNDLIB
int	    iswap;
int	    oswap;
#endif


// INPUT FILE HEADER INFO
float		idur;

float	ipeakamp[ 4 ];


int		window_type=0, 
		isr,
		ichan,
		idata_offset, 
		iformat, 
		outchan=0
;  
int
		IO_reset = 0, 
		sample=0, 
		begin_sample=0, 
		end_sample, 
		inbuffn=0, 
		doneflag=0, 
		quiet=0, 
		flinflag=0, 
		channelflag, 
		channow=0, 
		frame_count=0, 
		outputoff=0, 
		oscilbankon=0, 
		ttlsamps=0, 
		samps=0, 
		nsover[ 4 ] 
 
		
;

float
		begint=-1., 
		endt=-1.,
		ampstatinc=.25, 
		t=0., 
		tfactor=1, 
		frames_per_sec=200, 
		outdur   
; 


// OUTPUT FILE HEADER INFO
float		odur;
int		
		osr,
		ochan,
		odata_offset, 
		oformat, 
		outputformat=0		
;  


// RESCALE VALUE
float		
		rescalev=1
		;

//**************

// PRINT FUNCTIONS
int	
	prbanner( char *s,  int w ), 
	prt( char *s ), 	
	pri( int i,  char *s ),  
	prf( float f,  char *s ), 
	prs( char *r,  char *s ), 
	prline( int i, char *s  )
; 

// SHELF EQ
int eq(float SP[], int N, float dBlow, float dBhi,
	     float freqlow, float freqhi, float fundamental,  
	     float pmult,  float freqadd,  int normflag ) ;

// SHELF EQ
int eq2(float SP[], int N, float dBlow, float dBhi,
	     float freqlow, float freqhi, float fundamental,  
	     float channel_freqdev[],  int normflag ) ;


int eq3(float SP[], int N, float dBlow, float dBhi,
	     float freqlow, float freqhi ) ;


// CURVE FUNCTION
float curve( float V1, float  V2, float  n, float   x) ; 
// FIND A FILE FUNCTION VALUE
float fval( struct func *p, float dur, float  t ) ;
// FILL AN ARRAY FROM A FILE
float fillfunc( struct func *p, float *F, int N   ) ;

float semitones_to_mult( float semidev ) ; 
float dB_to_amp( float dB ) ;
float amp_to_dB( float amp ) ;  
float smooth_setup( float t, float *c, float *minusc, float IR ) ; 

float smooth_one_value(

    float A, 
    float old_A, 
    float att,
    float matt, 
    float rel, 
    float mrel

) ; 



// STRING PARSE FOR CRACK
FILE *crackstring( char  s[], struct func *p ) ; 
FILE *crackstring_bin_only( char  s[], struct func *p ) ; 

// SPECTRUM MAGNITUDE DISTRIBUTION WARPING
int spectmagwarp( float SP[],  int N,  float warpshape, int normflag ) ; 

// SPECTRUM MAGNITUDE DISTRIBUTION WARPING
int spectmagwarp2( float SP[], float SP_return[], int N,  float warpshape, int normflag ) ; 

// SPECTRUM MAGNITUDE DISTRIBUTION WARPING FOR INHARMONATOR
int spectmagwarp_inharm( float SP[], float F[],  int N,  float warpshape ) ; 

// SMOOTH THE SPECTRUM FOR USE AS A BASELINE
int smoothspec( float F[], int N2, float octaves,  int R ) ;

// SMOOTH THE CHANGES TO THE SPECTRUM
int smooth( float A[], float old_A[], int N, float att, float matt, float rel, float mrel ) ; 


int smoothnew( 
    float channel[], 
    int N,  
    float detectenv[], 
    float newenv[],  
    int N2,  
    float detect, 
    float mdetect, 
    float attackc, 
    float minusattackc, 
    float releasec, 
    float minusreleasec ) ; 




// SMOOTH THE AMP CHANGE MULTIPLIERS
int smooth_amp_change( float A[], float old_A[], int N2, float att, float matt, float rel, float mrel ) ; 

// SMOOTH THE CHANGES TO THE SPECTRUM
int smooth_zero( float A[], float old_A[], int N, float att, 
	float matt, float rel, float mrel,  float F[],  float gain ) ; 

// PRINT THE SPECTRUM VALUES AND GRAPH TO TERMINAL
int tprintspec( float F[], int N, float fundamental, int freqcutoff) ;
int tprintspec_groupdelay( float F[], int N, float fundamental, int freqcutoff) ;

// COMPRESS THE SPECTRUM
int compress( float SP[],  int N,  float filtcompthreshamp, float  filtcompamp, float filtcompnormamp ) ; 

// NORMALIZE THE SPECTRUM PEAKAMP
int normalize( float SP[],  int N,  float peakamp ) ; 

// GAIN SCALE THE MAGNITUDES
int gainscale( float SP[],  int N,  float amp ) ; 

// NORMALIZE THE SPECTRUM PEAKAMP
float RIfindpeak( float buffer[],  int N ) ; 

// PASS BACK TIME NOW
float timenow(float dur ) ; 

float randf( float min,  float max ) ;

// READ IN FFT HEADER VALUES
int readffthead( int *N, int *D, int *R, int *chans, int *win_type,  float peakamps[],  struct func *p ) ; 

// FIND THE PEAK AMP FOR THE FILE'S CHANNELS
float find_peak_amp( float Hwin[], float Wanal[], float Wsyn[], int N, int Nw,  
    int I, int D, int N2,  int R,  int obank,   float buffer[],   
    float channel[],   float input[],  int beginchan, int endchan )  ; 

// MAKE AN AVERAGE OR PEAK FREQRESPONSE
int make_freqresponse( float F[], float Hwin[], float Wanal[], float Wsyn[],   
    int N, int Nw, int I, int D, int N2, int R, int obank,   
    float buffer[], float channel[], float input[],   
    int method, float A_begint,  float A_endt ) ; 

// COMPANSION
int compand( float SP[], int N, float compthreshamp, float  compamp, 
    float expthreshamp, float expamp  ) ; 

// NOISE RESPONSE THRESHOLD LIMITING
int threshold_limit( float SP[],  int N,  
	float noise_thresh_limit_dB
    )  ;

// CENTROID PLUGIN
float find_centroid(

    float A[], 
    int N, 
    float lowf, 
    float hif, 
    float fundamental, 
    float *old_value

 ) ; 

// FLUXOID PLUGIN
float find_fluxoid(

    float A[], 
    float old_A[], 
    int N, 
    float lowf, 
    float hif, 
    float fundamental, 
    float *old_value, 
    int flux_weight_flag

 ) ; 

int cut_data_lines( 
    char datafile[],  
    char new_datafile[],  
    int data_size

) ;


