#include "globals.h"

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k, n,   i1,  i2,  ipartial,  np ;
float nyquist;
double atof();
 
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag=0,   channelout=0;

float P = 1.0;
FILE *fopen(), *fp;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *previous_channel,  *F,  *FT,  *harmony,  *previous_harmony ; 
float threshfac = .001,  threshfacdB=-96 ;
float	random_seed, gain=1. ;
float  temp,  temp2,  temp3 ;  
int beginchan,  endchan ; 
int sourceflag=1 ; 
float getthresh();
float  dBedge=-96.  ;
	float diff,  ireleasec, ireleasem,  
		    iattackc,    iattackm,  
		    ifreqsmoothc, ifreqsmoothm,  
		    sreleasec,  sreleasem,  
		    sattackc,  sattackm ; 

float   IR,  dur=0.,  pms,  pmnt,   pmt,  sgain ;

float dBhi=0,  dBlow=0, middB=0,   midfreq=1000,   eqshape=0.  ; 
int method_flag=0 ; 
double ar_dB ; 

FILE *data ; 
char datafile[ 128 ] = "EMPTY\0" ; 
float *PP,    fundamental,  target_gain,  non_target_gain, midC,  part ; 
int method=0 ; 

char tempstring[ 128 ] ; 

// MASTER GAIN
struct  func  dBgain ; 

// NON TARGET  FREQUENCY SHIFT ADDER
struct  func  NON_target_harmadd ; 

// NON TARGET  PITCH TRANSPOSITION IN SEMITONES
struct  func  NON_target_ptrans ; 

// NON TARGET DECIBELS
struct  func  NON_target_dB ; 

// FUNDAMENTAL FREQUENCY
struct  func  fund ; 

// TARGET DECIBELS
struct  func  target_dB ; 

// TARGET  FREQUENCY SHIFT ADDER
struct  func  target_harmadd ; 

// TARGET  PITCH TRANSPOSITION IN SEMITONES
struct  func  target_ptrans ; 

// FREQ SHIFT CONTROL
struct  func  target_shift_control ; 

//  INHARMONATOR RELEASE
struct  func  INHARM_release ; 

//  INHARMONATOR ATTACK
struct  func  INHARM_attack; 

//  FREQ MOVING AVERAGE COEFFICIENT
struct  func  INHARM_freqsmooth ; 


// SPECTRUM WARPSHAPE INDEX
struct  func  warpshape ; 


//*************** SOURCE 

// SOURCE  FREQUENCY SHIFT ADDER
struct  func  SOURCE_harmadd ; 

// SOURCE  PITCH MULTIPLIER
struct  func  SOURCE_ptrans ; 

// SOURCE DECIBELS
struct  func  SOURCE_dB ; 

//  SOURCE RELEASE
struct  func  SOURCE_release ; 

//  SOURCE ATTACK
struct  func  SOURCE_attack ; 

//********

#include "underflow.h"

//*****************INITIALIZE
// NON TARGET  FREQUENCY SHIFT ADDER
NON_target_harmadd.L = 1. ; NON_target_harmadd.n = 1. ; NON_target_harmadd.A[ 0 ] = 0. ; 

// GAIN
dBgain.L = 1. ;  dBgain.n = 1. ; dBgain.A[ 0 ] = 0. ; 

// NON TARGET  PITCH TRANSPOSITION IN SEMITONES
NON_target_ptrans.L = 1. ; NON_target_ptrans.n = 1. ; NON_target_ptrans.A[ 0 ] = 0. ; 

// FREQ SHIFT CONTROL
target_shift_control.L = 1. ; target_shift_control.n = 1. ; target_shift_control.A[ 0 ] = 1. ; 

// FUNDAMENTAL FREQUENCY
fund.L = 1. ; fund.n = 1. ; fund.A[ 0 ] = 60. ; 


// TARGET DECIBELS
target_dB.L = 1. ; target_dB.n = 1. ; target_dB.A[ 0 ] = 0. ; 

// NON TARGET DECIBELS
NON_target_dB.L = 1. ; NON_target_dB.n = 1. ; NON_target_dB.A[ 0 ] = 0. ; 

// TARGET  PITCH TRANSPOSITION IN SEMITONES
target_ptrans.L = 1. ; target_ptrans.n = 1. ; target_ptrans.A[ 0 ] = 0. ; 

// TARGET  FREQUENCY SHIFT ADDER
target_harmadd.L = 1. ; target_harmadd.n = 1. ; target_harmadd.A[ 0 ] = 0. ; 

//  INHARMONATOR RELEASE
INHARM_release.L = 1. ; INHARM_release.n = 1. ; INHARM_release.A[ 0 ] = 0. ; 

//  INHARMONATOR ATTACK
INHARM_attack.L = 1. ; INHARM_attack.n = 1. ; INHARM_attack.A[ 0 ] = 0. ; 

//  FREQ MOVING AVERAGE COEFFICIENT
INHARM_freqsmooth.L = 1. ; INHARM_freqsmooth.n = 1. ; INHARM_freqsmooth.A[ 0 ] = 0. ; 




// SOURCE  FREQUENCY SHIFT ADDER
SOURCE_harmadd.L = 1. ; SOURCE_harmadd.n = 1. ; SOURCE_harmadd.A[ 0 ] = 0. ; 

// SOURCE  PITCH MULTIPLIER
SOURCE_ptrans.L = 1. ; SOURCE_ptrans.n = 1. ; SOURCE_ptrans.A[ 0 ] = 0. ; 

// SOURCE DECIBELS
SOURCE_dB.L = 1. ; SOURCE_dB.n = 1. ; SOURCE_dB.A[ 0 ] = 0. ; 

//   SOURCE RELEASE
SOURCE_release.L = 1. ; SOURCE_release.n = 1. ; SOURCE_release.A[ 0 ] = 0. ; 

//   SOURCE ATTACK
SOURCE_attack.L = 1. ; SOURCE_attack.n = 1. ; SOURCE_attack.A[ 0 ] = 0. ; 

// SPECTRUM WARPSHAPE INDEX
warpshape.L = 1. ; warpshape.n = 1. ; warpshape.A[ 0 ] = 0. ; 



if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "N|M|w|D|I|W|A|a|_|=|P|G|q|X|W|m|S|Z|f|F|b|e|C|p|i|L|l|Y|Q|u|r|v|V|B|d|t|s|h", 0  )) != 0 ) {
	switch(ch) { 
	    case 'N':	N = atoi(arg_option);
			break;
	    case 'M':	Nw = atoi(arg_option);
			break;
	    case 'w':   window_type = atoi(arg_option) ;
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;
	    case 'I':   tfactor = atof(arg_option);
			break;
	    case 'A':   strcpy(tempstring, arg_option);
			dBgain.fp = crackstring( tempstring, 
			    &dBgain );
			break;

           case '_':	outputformat = atoi(arg_option) ; break;

           case '=':	rescalev = atof(arg_option) ; break;


	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;

            case 'p':	quiet = atoi(arg_option) ; break;
            case 'i':	ampstatinc = atof(arg_option) ; break;


	    case 'W':   strcpy(tempstring, arg_option);
			warpshape.fp = crackstring( tempstring, 
			    &warpshape );
			break;



// NON TARGETS
	    case 'a':   strcpy(tempstring, arg_option);
			NON_target_harmadd.fp = crackstring( tempstring, 
			    &NON_target_harmadd );
			break;
	    case 'P':   strcpy(tempstring, arg_option);
			NON_target_ptrans.fp = crackstring( tempstring, &NON_target_ptrans ); 
			break;
	    case 'G':   strcpy(tempstring, arg_option);
			NON_target_dB.fp = crackstring( tempstring, 
			    &NON_target_dB );
			break;

// TARGETS

	    case 'q':   strcpy(tempstring, arg_option);
			target_harmadd.fp = crackstring( tempstring, 
			    &target_harmadd );
			break;
	    case 'X':   strcpy(tempstring, arg_option);
			target_ptrans.fp = crackstring( tempstring, 
			    &target_ptrans );
			break;
	    case 'm':   strcpy(tempstring, arg_option);
			target_dB.fp = crackstring( tempstring, 
			    &target_dB );
			break;
	    case 'S':   strcpy(tempstring, arg_option);
			target_shift_control.fp = crackstring( tempstring, 
			    &target_shift_control );
			break;


	    case 'Z':   method = atoi(arg_option) ;
			break;

	    case 'f':   strcpy(tempstring, arg_option);
			fund.fp = crackstring( tempstring, 
			    &fund );
			break;

	    case 'F':   strcpy(datafile, arg_option);
			break;

	    case 'v':   strcpy(tempstring, arg_option);
			INHARM_attack.fp = crackstring( tempstring, 
			    &INHARM_attack );
			break;
	    case 'V':   strcpy(tempstring, arg_option);
			INHARM_release.fp = crackstring( tempstring, 
			    &INHARM_release );
			break;
	    case 'Y':   strcpy(tempstring, arg_option);
			INHARM_freqsmooth.fp = crackstring( tempstring, 
			    &INHARM_freqsmooth );
			break;

// SOURCE
	    case 'Q':   strcpy(tempstring, arg_option);
			SOURCE_harmadd.fp = crackstring( tempstring, 
			    &SOURCE_harmadd );
			break;
	    case 'u':   strcpy(tempstring, arg_option);
			SOURCE_ptrans.fp = crackstring( tempstring, &SOURCE_ptrans ); 
			break;
	    case 'r':   strcpy(tempstring, arg_option);
			SOURCE_dB.fp = crackstring( tempstring, 
			    &SOURCE_dB );
			break;

	    case 'l':   strcpy(tempstring, arg_option);
			SOURCE_attack.fp = crackstring( tempstring, 
			    &SOURCE_attack );
			break;
	    case 'L':   strcpy(tempstring, arg_option);
			SOURCE_release.fp = crackstring( tempstring, 
			    &SOURCE_release );
			break;

// END SOURCE


	    case 'B':   dBedge = atoi(arg_option) ;
			break;
	    case 't':	threshfacdB = atof(arg_option);
			break;
	    case 'h':	usage(1);
	}
    }
 

prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "INHARMONATOR", 69 ) ; 
prline( 69,  "-" ) ; 

    if(channelout == 0){
	channelflag = 0 ; 
	beginchan = 0 ;
    } else{
	channelflag = 1 ; 
	beginchan = channelout - 1 ; 
    }
 
// GET INPUT HEADER INFO AND SET UP OUTPUT FILE
    setupfiles(argc, argv) ; 

    endchan = beginchan + ochan ; 

// **** SET UPS *****
    R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    D = (int) ((float) R / frames_per_sec) ; 

    if(tfactor <= 0.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY A TIME FACTOR > 0. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 1.\n\n" ) ; 
	tfactor = 1. ; 
    }
    I = (int) ((float) D * tfactor ) ; 

//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
    if( Nw < I ){
	// INCREASE WINDOW SIZE TO ACCOMODATE INTERPOLATION
	Nw = 2 ; while( Nw <= I )Nw *= 2 ;
	prt( "\n----> INCREASING WINDOW SIZE TO ACCOMODATE TIME RESYNTHESIS INTERPOLATION. <---" ) ;
	pri( Nw,  "NEW WINDOW SIZE" ) ; 
    }
//*********************************

    IR = (float) I / (float) R ; 
    midC = (220.*pow(2., (3./12.))) ; 
    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    ar_dB =  (double) pow( (double) 10.0, (double) ( -60. / 20.) );	
    nyquist = R/2.0;
    obank = P != 0. ;
    if( P == 0.0 ) {P = 1.0;}
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    fundamental = (float) R / (float) N  ; 

    // COMPUTE THE DURATION
    dur = (endt - begint) * (float) I / (float) D ; 

//***************** PRINT VALUES
prf( dur, "OUTPUT FILE: DURATION" ) ; 

prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 

pri( frames_per_sec,  "FRAMES/SECOND" ) ; 
pri( tfactor,  "TIME EXPANSION/CONTRACTION FACTOR" ) ; 
prline( 1,  "*" ) ; 
pri( D,  "      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
pri( I,  "      INTERPOLATION SAMPLES (samples between resynthesis frames)" ) ; 
prline( 1,  "*" ) ; 
prf( threshfacdB, "OSCILLATOR RESYNTHESIS THRESHOLD (in dB)" ) ; 
prline( 1,  "*" ) ; 

prp( &dBgain,  "MASTER GAIN (in dB)" ) ;  
prline( 1,  "*" ) ; 

prp( &NON_target_harmadd,   "NON TARGETS: FREQUENCY SHIFT (in Hz)" ) ; 
prp( &NON_target_ptrans,  "NON TARGETS: PITCH TRANSPOSITION (in semitones)" ) ; 
prp( &NON_target_dB,  "NON TARGETS: GAIN (in dB)" ) ; 
prline( 1,  "*" ) ; 

prp( &fund,  "INHARMONATOR: FUNDAMENTAL FREQUENCY" ) ; 
prp( &INHARM_attack,  "INHARMONATOR: ENVELOPE ATTACK TIME(in secs)" ) ;
prp( &INHARM_release,  "INHARMONATOR: ENVELOPE RELEASE TIME(in secs)" ) ; 
prp( &INHARM_freqsmooth,  "INHARMONATOR: FREQUENCY CHANGE RESPONSE TIME(in secs)" ) ; 
prline( 1,  "*" ) ; 
prline( 1,  "*" ) ; 

prp( &target_dB,  "TARGETS: GAIN (in dB)" ) ; 
prp( &target_harmadd,  "TARGETS: FREQUENCY SHIFT (in Hz)" ) ; 
prp( &target_ptrans,  "TARGETS: PITCH TRANSPOSITION (in semitones)" ) ; 

prp( &target_shift_control,  "TARGETS: (0-1) SHIFT CONTROL" ) ; 
prline( 1,  "*" ) ; 

prp( &SOURCE_harmadd,  "SOURCE: FREQUENCY SHIFT (in Hz)" ) ; 
prp( &SOURCE_ptrans,  "SOURCE: PITCH TRANSPOSITION (in semitones)" ) ; 
prp( &SOURCE_dB,  "SOURCE: GAIN (in dB)" ) ; 
prp( &SOURCE_release,  "SOURCE: ENVELOPE RELEASE TIME(in secs)" ) ; 
prp( &SOURCE_attack,  "SOURCE: ENVELOPE ATTACK TIME(in secs)" ) ; 
prline( 1,  "*" ) ; 
prp( &warpshape, "TARGETS SPECTRUM WARPSHAPE INDEX" ) ; 
 
if( datafile ==  "EMPTY\0" ){
    fprintf( stderr,  "\n\nYOU MUST PROVIDE A DATA FILE. BYE.\n" ) ;
    exit(0);
}

if( (SOURCE_dB.A[0] > threshfacdB) || (SOURCE_dB.n != 1.)){
    // INCLUDE SOURCE
    sourceflag = 1 ;
    fprintf( stderr, "\n SOURCE SOUND INCLUDED......." ) ; 
    fprintf( stderr, "\n\t(SOURCE DECIBEL LEVEL BASED ON FUNCTION, \n\tOR IS > RESYNTHESIS THRESHOLD OF %f dB)", 
	threshfacdB ) ; 
}else{
    // EXCLUDE SOURCE
    sourceflag = 0 ; 
    fprintf( stderr, "\n ====> * SOURCE SOUND EXCLUDED * <=======" ) ; 
    fprintf( stderr, "\n\t(SOURCE DECIBEL LEVEL  < RESYNTHESIS THRESHOLD OF %f dB)", 
	threshfacdB ) ; 
}
    

    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
    fvec( previous_channel, N+2 ) ;	/* previous analysis channels */

// MAKE INHARMONATOR  ARRAY SPACE
    fvec( previous_harmony, N+2 ) ;	/* previous analysis channels */
    fvec( harmony, (N+2) ) ;	/* inharmonator channels */

// MAKE SHIFT ARRAY
    fvec( F, N+2 ) ;	/* SHIFT ARRAY */

// MAKE THRESH AMP
	threshfac = dB_to_amp( threshfacdB ) ; 

// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 



//**************************GET DATA	
// READ IN PARTIAL AMPS AND SHIFTS
// OPEN FILE
	if( (data = fopen( datafile, "r")) == NULL ){
	    fprintf( stderr, "\n%s <-- NO SUCH FILE. BYE.\n",  datafile ) ; 
	    exit(0); 
	}
// COUNT VALUES IN FILE
	k = 0 ; 
	while( fscanf( data,  " %f ",  &temp ) != EOF ) k++ ; 			
	np = k/3 ;  
	rewind( data ) ;    
// ALLOCATE SPACE FOR PARTIALS
    fvec( PP, k ) ;	/* PARTIALS */
// READ IN VALUES
//    while( fscanf( data,  " %f ",  &PP[ k ] ) != EOF ) k++ ; 			


prline( 69,  "-" ) ;
prbanner( "INHARMONATOR: DATAFILE VALUES", 69 ) ; 
prp( &fund,  "INHARMONATOR: FUNDAMENTAL FREQUENCY" ) ; 
prline( 69,  "-" ) ;

if(method == 0){
    fprintf( stderr,  "\n***************************************" ) ; 
    fprintf( stderr,  "\nPartial     |Multiplier  |Decibels    |" ) ; 
    fprintf( stderr,  "\nNumber      |Shift       |            |" ) ; 
    fprintf( stderr,  "\n            |Factor      |            |" ) ; 

}else if(method == 1){
    fprintf( stderr,  "\n***************************************" ) ; 
    fprintf( stderr,  "\nPartial     |Frequency   |Decibels    |" ) ; 
    fprintf( stderr,  "\nNumber      |Shift       |            |" ) ; 
    fprintf( stderr,  "\n            |Point       |            |" ) ; 

}else if(method == 2){
    fprintf( stderr,  "\n***************************************" ) ; 
    fprintf( stderr,  "\nPartial     |Octave.Pitch|Decibels    |" ) ; 
    fprintf( stderr,  "\nNumber      |Class       |            |" ) ; 
    fprintf( stderr,  "\n            |Shift Point |            |" ) ; 

}else if(method == 3){
    fprintf( stderr,  "\n***************************************" ) ; 
    fprintf( stderr,  "\nPartial     |Partial     |Decibels    |" ) ; 
    fprintf( stderr,  "\nNumber      |Number      |            |" ) ; 
    fprintf( stderr,  "\n            |Shift Point |            |" ) ; 

}else{
    fprintf( stderr, "\n\n%d IS NOT AN ACCEPTED DATA FORM\n\n",  method ) ; 
    exit(0) ; 
}
    fprintf( stderr,  "\n......................................|" ) ; 

// READ IN VALUES
k = 0 ; 
for( i = 0; i < np ; i++ ){
    fprintf( stderr,  "\n" ) ;
    for( j = 0; j < 3 ; j++ ){
	    fscanf( data,  " %f ",  &PP[ k ] ) ; 
	    fprintf( stderr,  "%-12.3f|", PP[ k ]  ) ;
	     k++ ; 			
    }
} 
    fprintf( stderr,  "\n***************************************" ) ; 
    fprintf( stderr,  "\n\n" ) ; 



//************************************
//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(outchan = beginchan,  channow = 0; outchan < endchan; outchan++,  channow++ ){

prline( 69,   "=" ) ; 
pri( (outchan+1), "ANALYSIS: CHANNEL" ) ; 

    //*****   REINITS
    frame_count = 0 ;    eof = 0 ; 


   makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;
	
//*********************************************
// LOOP FOR FRAMES
//*********************************************

    while ( !eof ) {
	in += D ;
	on += I ;
	timenow( dur ) ;

	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;
	  	  convert( buffer, channel, N2, D, R ) ;

	// SETUP PREVIOUS CHANNEL
	    if( !frame_count )for(i = 0; i < N; i++)
		    previous_channel[ i ] = channel[ i ] ; 




//*************************
// GET THE VALUES
//*************************

//  SHIFT, GAIN, AND MULTIPLIER

// ALL
		dBgain.A[ 0 ] =  fval( &dBgain, dur, t );
		    gain = dB_to_amp( dBgain.A[ 0 ] ) ; 


//***** INHARMONATOR


		INHARM_freqsmooth.A[ 0 ] = fval( &INHARM_freqsmooth, dur, t );
		    smooth_setup( INHARM_freqsmooth.A[ 0 ], &ifreqsmoothc, &ifreqsmoothm, IR ) ; 


		INHARM_release.A[ 0 ] = fval( &INHARM_release, dur, t );
		    smooth_setup( INHARM_release.A[ 0 ], &ireleasec, &ireleasem, IR ) ; 


		INHARM_attack.A[ 0 ] = fval( &INHARM_attack, dur, t );
		    smooth_setup( INHARM_attack.A[ 0 ], &iattackc, &iattackm, IR ) ; 

		warpshape.A[ 0 ] =  fval( &warpshape, dur, t );



// TARGETS
		fund.A[ 0 ] =  fval( &fund, dur, t );
		target_harmadd.A[ 0 ] =  fval( &target_harmadd, dur, t );
		target_ptrans.A[ 0 ] = fval( &target_ptrans, dur, t );
		    pmt = semitones_to_mult( target_ptrans.A[ 0 ] ) ;
		target_dB.A[ 0 ] =  fval( &target_dB, dur, t );
		    target_gain = dB_to_amp( target_dB.A[ 0 ] ) ; 
		target_shift_control.A[ 0 ] =  fval( &target_shift_control, dur, t );


// NONTARGETS

		NON_target_harmadd.A[ 0 ] =  fval( &NON_target_harmadd, dur, t );
		NON_target_ptrans.A[ 0 ] = fval( &NON_target_ptrans, dur, t );
		    pmnt = semitones_to_mult( NON_target_ptrans.A[ 0 ] ) ;
		NON_target_dB.A[ 0 ] =  fval( &NON_target_dB, dur, t );
		    non_target_gain = dB_to_amp( NON_target_dB.A[ 0 ] ) ; 


//***** SOURCE
		if(sourceflag){
		    SOURCE_harmadd.A[ 0 ] =  fval( &SOURCE_harmadd, dur, t );
		    SOURCE_ptrans.A[ 0 ] = fval( &SOURCE_ptrans, dur, t );
			pms = semitones_to_mult( SOURCE_ptrans.A[ 0 ] ) ;
		    SOURCE_dB.A[ 0 ] =  fval( &SOURCE_dB, dur, t );
			sgain = dB_to_amp( SOURCE_dB.A[ 0 ] ) ; 

		    SOURCE_release.A[ 0 ] = fval( &SOURCE_release, dur, t );
			smooth_setup( SOURCE_release.A[ 0 ], &sreleasec, &sreleasem, IR ) ; 

		    SOURCE_attack.A[ 0 ] = fval( &SOURCE_attack, dur, t );
			smooth_setup( SOURCE_attack.A[ 0 ], &sattackc, &sattackm, IR ) ; 

		}

//*************************

//** GET NEW VALUES IF  FIRST, OR IF FUNDAMENTAL OR SHIFT CONTROL ARE CHANGING
if( (frame_count == 0) || (fund.n > 1.) || (target_shift_control.n > 1) ){

//************************* SET UP FILTER ARRAY
// INITIALIZE SPACE
    for(i = 1; i < N ; i += 2 ){
	F[ i ] = 1. ; F[ i - 1 ] = -1. ;
    }
    // STEP THROUGH ALL  PARTIALS
    for( j = 0; j < k; j += 3 ){



	// FREQ OF PARTIAL
	part = fund.A[ 0 ] * PP[ j ] ; 
	// INDEX OF PARTIAL
	ipartial = 1 + (2 * ( rint((double)((PP[ j ] * fund.A[ 0 ]) / fundamental)) )) ; 
	// INDEX OF 1/2 PARTIAL BELOW
	i1 = 1 + (2 * ( rint((double)(((PP[ j ] - .5) * fund.A[ 0 ]) / fundamental)) )) ; 
	// INDEX OF 1/2 PARTIAL ABOVE
	i2 = 1 + (2 * ( rint((double)(((PP[ j ] + .5) * fund.A[ 0 ]) / fundamental)) ))  ;  
    // CHANGE RANGE OF FILTER 1/2WAY ABOVE AND BELOW PARTIAL POINT.

//**** SETUP THE BIN OF THE PARTIAL
	i = ipartial ; 
	    if( ( i >= 0 ) && (i < N ) ){

		if( method == 2 ){

		    //**** OCTAVE.PITCHCLASS
		    temp = (float) ((int) PP[j + 1] ) ; // INTEGER PART
		     temp =  (( 12. * (temp - 8.)) + 
				(100. * (PP[j + 1] - temp)) ) / 12. ;
		    F[ i ] = (midC * pow( 2., (double) temp )) / part ; 

		} else if(method == 1) {

		    //**** FREQ SHIFT POINT
		    F[ i ] = PP[ j + 1 ] / part ; 

		} else if(method == 0) {

		    //**** MULTIPLER 
		    F[ i ] = PP[ j + 1 ] ;

		}else if(method == 3) {
		    
		    //**** PARTIAL SHIFT POINT
		     F[ i ] =  (PP[ j + 1 ] * fund.A[ 0 ] ) / part ;    

		}else {
		    fprintf( stderr, "\n\n%d IS NOT AN ACCEPTED DATA FORM\n\n",  method ) ; 
		    exit(0) ; 
		}
		
		    // APPLY SHIFT CONTROL PANPOT
		    F[ i ] = 1. + 
			(target_shift_control.A[ 0 ] * (F[ i ] - 1.)) ;
		    // DB TO AMP FOR PARTIAL BINS
		F[ i - 1 ] = pow( (double) 10.0, (double) (PP[ j + 2 ] /20.) );
	    } 

//**** SETUP THE BINS BELOW THE PARTIAL
	  for(i = i1,  n = 0;  i < ipartial; i += 2,  n += 2 ){
	    if( ( i >= 0 ) && (i < N ) ){

		if( method == 2 ){

		    //**** OCTAVE.PITCHCLASS
		    temp = (float) ((int) PP[j + 1] ) ; // INTEGER PART
		     temp =  (( 12. * (temp - 8.)) + 
				(100. * (PP[j + 1] - temp)) ) / 12. ;
		    F[ i ] = (midC * pow( 2., (double) temp )) / part ; 

		} else if(method == 1) {

		    //**** FREQ SHIFT POINT
		    F[ i ] = PP[ j + 1 ] / part ; 

		} else if(method == 0) {

		    //**** MULTIPLER 
		    F[ i ] = PP[ j + 1 ] ;

		}else if(method == 3) {
		    
		    //**** PARTIAL SHIFT POINT
		     F[ i ] =  (PP[ j + 1 ] * fund.A[ 0 ] ) / part ;    
		    
		}else {
		    fprintf( stderr, "\n\n%d IS NOT AN ACCEPTED DATA FORM\n\n",  method ) ; 
		    exit(0) ; 
		}
		
		
		    // APPLY SHIFT CONTROL PANPOT
		    F[ i ] = 1. + 
			(target_shift_control.A[ 0 ] * (F[ i ] - 1.)) ;
		    // DB TO AMP FOR PARTIAL BINS
		temp = (1. - (float) (n / (ipartial - i1))) *  dBedge ; 
		F[ i - 1 ] = pow( (double) 10.0, (double) ((PP[ j + 2 ] + temp) /20.) );
	    } 
	}
//**** SETUP THE BINS ABOVE THE PARTIAL
	  for(i = i2,  n = 0;  i > ipartial; i -= 2,  n += 2 ){
	    if( ( i >= 0 ) && (i < N ) ){

		if( method == 2 ){

		    //**** OCTAVE.PITCHCLASS 
		    temp = (float) ((int) PP[j + 1] ) ; // INTEGER PART
		     temp =  (( 12. * (temp - 8.)) + 
				(100. * (PP[j + 1] - temp)) ) / 12. ;
		    F[ i ] = (midC * pow( 2., (double) temp )) / part ; 

		} else if(method == 1) {

		    //**** FREQ SHIFT POINT
		    F[ i ] = PP[ j + 1 ] / part ; 

		} else if(method == 0) {

		    //**** MULTIPLER 
		    F[ i ] = PP[ j + 1 ] ;

		}else if(method == 3) {
		    
		    //**** PARTIAL SHIFT POINT
		     F[ i ] =  (PP[ j + 1 ] * fund.A[ 0 ] ) / part ;    
		    
		}else {
		    fprintf( stderr, "\n\n%d IS NOT AN ACCEPTED DATA FORM\n\n",  method ) ; 
		    exit(0) ; 
		}
		
		    // APPLY SHIFT CONTROL PANPOT
		    F[ i ] = 1. + 
			(target_shift_control.A[ 0 ] * (F[ i ] - 1.)) ;
		    // DB TO AMP FOR PARTIAL BINS
		temp = (1. - (float) (n / (i2 - ipartial))) *  dBedge ; 
		F[ i - 1 ] = pow( (double) 10.0, (double) ((PP[ j + 2 ] + temp) /20.) );
	    } 
	}

    }



}
//*************************END FILTER ARRAY SETUP

 



//************DEBUG
/*
	fprintf( stderr,"\n***********************");  
		 for( i = 1; i < 100; i = i + 2){
		 	fprintf( stderr,  
	    "\nF[ %d ]: %f, F[ %d  ]: %f, channel[%d]: %f",
		i, F[ i ], (i-1),  F[ i - 1 ] , i,   channel[ i ] ) ; 
		}

*/



//*****************
// MODIFICATIONS LOOPS
//*****************

 // ***** APPLY MASTER GAIN
    for( i = 0; i < N; i = i + 2) channel[i] = channel[i] * gain ; 


// INHARMONATOR


    for( i = 1; i < N; i = i + 2){
 		// ***** TRANSFER TO INHARMONATOR ARRAY
	    harmony[i] = channel[i] ; 
	    harmony[i - 1] = channel[i - 1] ; 
    }	    


// ************* INHARMONATOR CHANGES *******************




		    
    for( i = 1; i < N; i = i + 2){
	    // PITCH CHANGES
		    if( F[i - 1] != -1. ){
		    // TARGETS
			// FREQ
			temp = pmt *  
			    ( (harmony[i] *  F[ i ]) + target_harmadd.A[ 0 ]) ; 
			// AMP
			harmony[i - 1] = harmony[i - 1] * F[i - 1] * target_gain;  
		    }else{
		    // NON TARGETS
			// FREQ
			temp = 
			    pmnt * (harmony[i] + NON_target_harmadd.A[ 0 ]) ;
			// AMP
			harmony[i - 1] = harmony[i - 1] * non_target_gain ; 			
		    }  
		    

//************ SMOOTH FREQ CHANGES
		    harmony[i] = 
			    (ifreqsmoothc * previous_harmony[i] )
				+ ( ifreqsmoothm * harmony[i] );
		    previous_harmony[i] = harmony[i] ; 
		    
		    if(temp > 0.) harmony[i] = temp ;
		    else harmony[i - 1] = 0. ;  

		    if(harmony[i] >= nyquist) harmony[i-1] = 0. ; 
 
 //******* 
    }


//*************WARP THE TARGETS SPECTRUM
    spectmagwarp_inharm( harmony, F,  N, warpshape.A[ 0 ] ) ;


//************ATTACK AND RELEASE BOTH TARGETS AND NON
    // SMOOTH THE CHANGES TO THE SPECTRUM
    smooth( harmony, previous_harmony, N, iattackc, iattackm, ireleasec, ireleasem ) ; 


// *************END OF INHARMONATOR CHANGES *******************


//*************** SOURCE CHANGES ***********
// SOURCE
		 if(sourceflag){

		    // SMOOTH THE CHANGES TO THE SPECTRUM
		    smooth( channel, previous_channel, N, sattackc, sattackm, sreleasec, sreleasem ) ; 

		   for( i = 1; i < N; i = i + 2){
		    //** GAIN
		    channel[i - 1] = channel[i - 1] * sgain ; 

		    //** ADD/TRANSPOSE 
		    temp = pms *  (SOURCE_harmadd.A[ 0 ] + channel[i] ) ;   

		    // ZERO BINS OUT OF 0-Nyquist FREQUENCY RANGE
		    if((temp <= 0.) || (temp >= nyquist)) channel[i - 1] = 0. ; 
		    else  channel[i] = temp ;
 
 //*************** END  SOURCE CHANGES ***********


		  }
		}
		
	    if(sourceflag){
		synt = getthresh( channel, N, threshfac );
		temp = getthresh( harmony, N, threshfac );
		if(temp > synt) synt = temp ; 
	    }else{
		temp = getthresh( harmony, N, threshfac );
	    }


	    if(sourceflag){
		// DO BOTH
		noscbank2(channel, N2, R, Nw, I, P,  output,  harmony, N2 );
	    }else{
		// ONLY DO INHARMONATOR
		noscbank(harmony, N2, R, Nw, I, P, output);
	    }

	    shiftout( output, Nw, I, on+Nw-I, 0 ) ;

	    frame_count++ ; 
    // FRAMES LOOP END

    }


    // FLUSH OUT AND CLOSE OUTPUT FILE
    shiftout( output, Nw, I, 1, 1 ) ;

    
// CHANNELS LOOP END
} 

    // CLOSE  INPUT FILE
    fclose(ifd) ;  











    fprintf(stderr,"\n\nINHARMONATOR : RESYNTHESIS COMPLETED\n");

 
    if( dBgain.n != 1. ) fclose(dBgain.fp ) ;

    if( NON_target_harmadd.n != 1. ) fclose(NON_target_harmadd.fp ) ;
    if( NON_target_ptrans.n != 1. ) fclose(NON_target_ptrans.fp ) ;
    if( NON_target_dB.n != 1. ) fclose(NON_target_dB.fp ) ;

    if( target_harmadd.n != 1. ) fclose(NON_target_harmadd.fp ) ;
    if( target_ptrans.n != 1. ) fclose(target_ptrans.fp ) ;
    if( target_dB.n != 1. ) fclose(target_dB.fp ) ;
    if( target_shift_control.n != 1. ) fclose(target_shift_control.fp ) ;
    if( fund.n != 1. ) fclose(fund.fp ) ;

  if( INHARM_release.n != 1. ) fclose(INHARM_release.fp ) ;
  if( INHARM_attack.n != 1. ) fclose(INHARM_attack.fp ) ;
  if( INHARM_freqsmooth.n != 1. ) fclose(INHARM_freqsmooth.fp ) ;
  if( SOURCE_harmadd.n != 1. ) fclose(SOURCE_harmadd.fp ) ;
  if( SOURCE_ptrans.n != 1. ) fclose(SOURCE_ptrans.fp ) ;
  if( SOURCE_dB.n != 1. ) fclose(SOURCE_dB.fp ) ;
  if( SOURCE_release.n != 1. ) fclose(SOURCE_release.fp ) ;
  if( SOURCE_attack.n != 1. ) fclose(SOURCE_attack.fp ) ;
  if( warpshape.n != 1. ) fclose(warpshape.fp ) ;


    
    fclose( data ) ; 
 


    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"inharmonator:  harmonic partials remapper\n"
	"inharmonator   [flags] [input file (16-bit shorts)] [output file (optional)]\n"
	"	N:	fft length [1024]\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	w:	window type: 0 = hamming,  1 = rectangular  \n"
	"		    2 = Blackman,  3 = Bartlett triangular [0.]\n"
	"	D:	analysis frames per second [200]\n"
	"	I:	time expansion/contraction factor  [1.] \n"
	"		  (duration = duration * factor, 1. = original time) \n"
	"	A:	master gain in decibels (func) [0.] \n"
	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (0. = end of file) [0.] \n"
	"	C:	resynthesis channel(s) (1 -> ?) (0 = all) [0] \n"

	"	    SOURCE PARAMETERS:\n"
	"	Q:	frequency shift factor \n"
	"		    (bin frequency adder, before -P )(func)[0.] \n"
	"	u:	pitch transposition in semitones (func)[0]\n"
	"	r:	gain in decibels (func) [0.] \n"
	"	l:      envelope attack time  (func) [0.]\n"
	"	L:      envelope release time   (func) [0.]\n"
	"	    INHARMONATOR PARAMETERS:\n"
	"	f:	fundamental frequency of remapping scheme  (func) [60.] \n\n"
	"	v:      envelope attack time  (func) [0.]\n"
	"	V:      envelope release time   (func) [0.]\n"
	"	Y:      frequency change response time  (func) [0.]\n\n"
	"	a:	NON TARGETS: frequency shift factor \n"
	"		    (bin frequency adder, before -P )(func)[0.] \n"
	"	P:	NON TARGETS: pitch transposition in semitones (func)[0]\n"
	"	G:	NON TARGETS: gain control in decibels (func) [0.] \n\n"
	"	q:	TARGETS: frequency shift factor \n"
	"		    (bin frequency adder, before -P )(func)[0.] \n"
	"	X:	TARGETS: pitch transposition in semitones (func)[0]\n"
	"	m:	TARGETS: gain control in decibels (func) [0.] \n"
	"	S:	TARGETS: proportion of data file frequency shift (0-1)(func) [1.] \n"
	"		    (0 = no shift,  1 = full shift)\n"
	"	W:	TARGETS: spectrum warp index for reshaping magnitude response (func) [0.] \n"
	"		    Values > 0 expand the dynamic range, \n"
	"		    values < 0 compress the dynamic range. \n"
	"	B:	dB level at boundaries of partial band [-96.]\n"
	"		    (relative to partial dB)\n"
	"		    (boundaries lie 1/2way between partials) \n\n"
	"	F:	(ascii) DATA FILE of unordered, selected partial triples:\n"
	"		     Each consisting of: \n"
	"			partial number, shift(see below), and decibels\n"
	"	Z:	SHIFT DATA FORMAT: [0]\n"
	"		     0 = transposition multiplier\n"
	"		     1 = frequency shift point\n"
	"		     2 = octave.pitch_class shift point\n"
	"		     3 = partial number of fundamental shift point\n\n"
	"	t:	oscillator resynthesis threshold in decibels [ -60 ]\n"
	"	p:	amplitude reports print mode: 0 = off, 1 = on [0]\n" 
	"	i:	time interval between amplitude reports [.25]\n" 
	);
    exit(woof);
}





int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

