#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "globals.h"

#define SND_MAGIC ((int)0x2e736e64)
#define SND_FORMAT_UNSPECIFIED          (0)
#define SND_FORMAT_MULAW_8              (1)
#define SND_FORMAT_LINEAR_8             (2)
#define SND_FORMAT_LINEAR_16            (3)
#define SND_FORMAT_LINEAR_24            (4)
#define SND_FORMAT_LINEAR_32            (5)
#define SND_FORMAT_FLOAT                (6)
#define SND_FORMAT_DOUBLE               (7)


#define BLOCKSIZE 1024
/*
* THIS ROUTINE READS THE SHORTS OF THE SPECIFIED FILE AND 
* CHANNEL AND WRITES THEM AS FLOATS TO THE STANDARD OUT
*
*/

/* CRACK STUFF */
extern int arg_index;
extern char *arg_option;
extern int bannerflag;


/************************************************************/

int main(argc,argv)
   int argc;
   char *argv[]; 
   {
   

    char	
		*leftfilename, 
		*rightfilename, 
		*outputfilename, 
		ch, 
		crack()
    ;

    
    int		exflag=0, 
		exflagl=0,
		exflagr=0, 
		numreadr, 
		numreadl, 
		n,nn,  
		numbytes, 
		i,
		urate=0,  
		lsr, rsr, osr,  
		lchan, rchan, ochan, 
		ldata_offset, rdata_offset, odata_offset, 
		lformat, rformat, oformat, 
		fdleft, fdright, fdoutput
    ;
	
    short int	idata
    ; 

    char	leftdata[ BLOCKSIZE ],  rightdata[ BLOCKSIZE ],  output_array[ BLOCKSIZE * 2 ]
    ;		
    float	ldur, rdur, 
		out, 
		begin, 
		end
    ;

int getsfstats(char *filename, int *sr, int *chan, float *dur, int *data_offset, int *format) ; 

typedef struct {
        int magic;          /* must be equal to SND_MAGIC */
        int dataLocation;   /* Offset or pointer to the raw data */
        int dataSize;       /* Number of bytes of data in the raw data */
        int dataFormat;     /* The data format code */
        int samplingRate;   /* The sampling rate */
        int channelCount;   /* The number of channels */
        char info[4];       /* Textual information relating to the sound. */
} 
SNDSoundStruct;

   SNDSoundStruct newheader;
   struct       stat st;


/*GIVE USAGE AND EXIT IF NO ARGUMENTS */
   if(argc == 1) {
	fprintf( stderr,"%s%s%s%s", 
	"\n\nUSAGE:\n\n   monotostereo (NeXT/Sun format files:) <left> <right> <stereo.snd>\n\n", 
	"\tThe left and right monophonic (NeXT/Sun format) input sound files ", 
	"\n\tare interleaved into a stereo (NeXT/Sun format) output sound file.", 
	"\n\tThe duration is determined by the shorter of the two files.\n\n" 
	 ) ;
	exit(0);
    }
    
    numbytes = BLOCKSIZE ; 
/*
    while((ch = crack(argc,argv,"u",0)) != 0)
{
        switch(ch) {
            case 'u': urate = atoi(arg_option) ;                  break;
	    
        }
    }
*/
    if( argc < 2 ){
	banner() ; 
	fprintf( stderr, "\nWHERE ARE THE FILES? BYE.\n\n") ;
        exit(0)  ;	
    }
    if( argc < 3 ){
	banner() ;
	fprintf( stderr, "\nI NEED THE RIGHT SIDE TOO!. BYE\n\n") ;
        exit(0)  ;	
    }

/* GET SOUNDFILE NAME AND OPEN FOR BUSINESS */
   leftfilename = argv[1] ;
   rightfilename = argv[2] ;
   if( argc < 4 ) {
	outputfilename = "stereo.snd" ;
	banner() ;
	fprintf( stderr,  "\nDEFAULT OUTPUT FILE = stereo.snd\n" ) ;
    } else
	outputfilename = argv[3] ;


        exflagl = getsfstats(leftfilename, &lsr, &lchan, &ldur, &ldata_offset, &lformat) ; 
		
		
        exflagr = getsfstats(rightfilename, &rsr, &rchan, &rdur, &rdata_offset, &rformat) ; 

	
	if( ( exflagl == -2 ) || ( exflagr == -2 ) ) {
	    banner() ;
	    fprintf( stderr, "\n\n\t....FIX THE FORMAT OF YOUR FILE(S). BYE.\n\n" ) ;
	    exit(0) ; 
	}
	if( ( exflagl == -1 ) || ( exflagr == -1 ) ) {
	    banner() ;
	    fprintf( stderr, "\n\n\t....FIX YOUR FILE (PATH)NAME(S). BYE.\n\n" ) ;
	    exit(0) ; 
	}
		 
/* CHECK FOR MONO FILES */
	if( lchan != 1 ) {
	    banner() ;
	    fprintf(stderr,  "\nYOUR LEFT CHANNEL FILE:\n\n------> %s <-------\n\n IS NOT MONO.\n\n", leftfilename );
	}
	if( rchan != 1 ) {
	    banner() ;
	    fprintf(stderr,  "\nYOUR RIGHT CHANNEL FILE:\n\n------> %s <-------\n\n IS NOT MONO.\n\n", rightfilename );
	}
	if( rchan != 1 || lchan != 1 ) {
	    banner() ;
	    fprintf(stderr,  "\n.........MAKE SURE YOUR LEFT AND RIGHT CHANNEL FILES ARE MONO. BYE.\n\n");
	    exit(0) ; 
	}

/*
        fprintf(stderr,  "*LEFT: %s\n\tsr=%d, chan=%d, dur=%f, data_offset=%d, format=%d\n", \
                 leftfilename, lsr, lchan, ldur, ldata_offset, \
                 lformat);
       fprintf(stderr,  "*RIGHT: %s\n\tsr=%d, chan=%d, dur=%f, data_offset=%d, format=%d\n", \
                 rightfilename, rsr,rchan,rdur, rdata_offset, \
                 rformat);
*/

/*
/* CHECK FOR STUPIDITY */
    if( lformat != 3 ){
	    banner() ;
        fprintf( stderr, "\n\nYOUR LEFT CHANNEL FILE IS NOT A NEXT FORMAT FILE.\n\n" ) ;
    }
    if( rformat != 3 ){
	    banner() ;
        fprintf( stderr, "\n\nYOUR LEFT CHANNEL FILE IS NOT A NEXT FORMAT FILE.\n\n" ) ;
    }
    if( lformat != 3  ||  rformat != 3 ){
	    banner() ;
	 fprintf( stderr, "\nUSE nexts OR nextd TO CHANGE THE FORMAT OF YOUR FILES.\n\t...................BYE.\n\n" ) ;
	 exit(0) ; 
    }
/* OPEN FILES */
    fdleft = open( leftfilename, O_RDWR,(0644)); 
    fdright = open( rightfilename, O_RDWR,(0644)); 

/* OPEN OUPUT FILE */
    fdoutput = open( outputfilename,O_RDWR,(0644));
    if(fdoutput < 0) {
	fprintf( stderr,  "%s DOES NOT YET EXIST. I'LL MAKE IT.\n", 
	    outputfilename );
	exflag = open(outputfilename, O_CREAT,(0644)); 
	if( exflag == -1 ){
		
	    banner() ;
		fprintf( stderr,  "\n\n I COULD NOT MAKE THE FILE:\n\n-----> %s <-------\n\n",  outputfilename ) ; 
		fprintf( stderr,  "\n\n CHECK THE PATH OF YOUR FILE. ....BYE.\n\n" ) ; 
		exit( 0 ) ; 
	}
	
	fdoutput = open(outputfilename, O_RDWR,(0644));
    }else{
	open(outputfilename, O_TRUNC, (0644));
    }

/* WRITE 1024 dummy bytes for the header */
    idata = 0 ;
    for( i = 0; i < 512 ; i++)
	write( fdoutput,  &idata, sizeof(short int) ) ;

/* MAKE IT A SOUNDFILE BY WRITING THE HEADER */

        /* Now,create new header  and slap it at the front of this soundfile*/

        newheader.magic = SND_MAGIC;
        odata_offset = 1024 ;
        newheader.dataLocation = odata_offset;
        newheader.dataFormat = SND_FORMAT_LINEAR_16 ;
        newheader.samplingRate = 44100 ;
        newheader.channelCount = 2 ;


        if(stat(outputfilename,&st))  {
                fprintf(stderr, "\nputlength: (#1)  Couldn't stat file\n\n");
                exit(1);
        }
        newheader.dataSize = (int)st.st_size - odata_offset ;
/*
fprintf( stderr,  "\n dataSize = %d",  (int)newheader.dataSize ) ; 
*/
	 /* this captures the whole size of the file */

    	lseek(fdoutput, 0, SEEK_SET);
        if((write( fdoutput, &newheader, sizeof(newheader) ) == -1))
                        fprintf( stderr, "\ncouldn\'t write header\n\n");

	lseek( fdoutput, odata_offset, SEEK_SET ) ;
    

/* SKIP TO DATA OFFSET OF INPUT FILES + BEGIN */
	
	lseek( fdleft, ldata_offset, SEEK_SET ) ;
	lseek( fdright, rdata_offset, SEEK_SET ) ;
	n = 0 ; nn = 0 ;  


/* READ IN THE VALUES */
    numreadl = read( fdleft,   &leftdata,  numbytes * sizeof(ch)  ) ; 
    numreadr = read( fdright,  &rightdata, numbytes * sizeof(ch) ) ; 
    
    while( (numreadl  > 0 ) && (numreadr > 0 ) ) {
    /*
     * INTERLEAVE THE TWO
     * 
     */
     
	if( numreadl < numreadr ) numreadr = numreadl ; 
	
	
	for( n = 0; n < (numreadr * 2) ; n += 4 ){
	    output_array[ n ] = leftdata[ n / 2 ] ; 
	    output_array[ n + 1 ] = leftdata[ (n / 2) + 1 ] ; 
	    output_array[ n + 2 ] = rightdata[ n / 2 ] ; 
	    output_array[ n + 3 ] = rightdata[ (n / 2) + 1 ] ; 
/*
	fprintf( stderr,  "\nfilling array: n = %d ",  n ) ; 
*/	
	}

	write( fdoutput,  &output_array, sizeof(ch) * numreadr * 2 ) ;
	nn = numreadr * 2 + nn ; 
/*
	fprintf( stderr,  "\nnumreadl = %d,  numreadr = %d, nn = %d", numreadl,   numreadr,  nn ) ; 
*/	
    numreadl = read( fdleft,  &leftdata, numbytes * sizeof(ch)  ) ; 
    numreadr = read( fdright,  &rightdata, numbytes * sizeof(ch) ) ; 

	}




    
     

/**********/

/* PUT THE HEADER ON THE FILE AND CLOSE IT */

        /* Now,create new header  and slap it at the front of this soundfile*/

        newheader.magic = SND_MAGIC;
        odata_offset = 1024 ;
        newheader.dataLocation = odata_offset;
        newheader.dataFormat = SND_FORMAT_LINEAR_16 ;
        newheader.samplingRate = 44100 ;
        newheader.channelCount = 2 ;


        if(stat(outputfilename,&st))  {
                fprintf(stderr, "putlength: (#2) Couldn't stat file\n");

                exit(1);

        }
        newheader.dataSize = (int)st.st_size - odata_offset ;
	 /* this captures the whole size of the file */
/*
fprintf( stderr,  "\nDATA SIZE: newheader.dataSize = %d,  %d",  (int) newheader.dataSize, (int)st.st_size  ) ; 
*/

    	lseek(fdoutput, 0, SEEK_SET);
        if((write( fdoutput, &newheader, sizeof(newheader) ) == -1))
                        fprintf(stderr,  "\ncouldn\'t write header\n\n");
        close( fdoutput ) ;
        close( fdleft ) ;        
	close( fdright ) ;

exit(0) ; 




}


int banner(){
    if( bannerflag == 0 )
    fprintf( stderr,  "\n\n*************************************\n*********   MONOTOSTEREO   **********\n*************************************\n" ) ;
			 bannerflag = 1 ; 
}	
