#include "globals.h"

main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,k, jj,   i1,  i2 ;
float i1p,  i2p,  pm,  fm,  fs ; 
float nyquist;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 256, I = 256, in, on;
int   eof = 0, obank = 0,  sflag = 0,  channelout=0 ;
float P = 1.0;

float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,  *output ;
float *previous_channel, *smooth_channel,  *F, *amp_change, 
	  *previous_amp_change ; 
float threshfac = .001,  threshfacdB=-96 ;
float releasec,  minusreleasec,  attackc,  minusattackc ; 
double ar_dB ; 
float	gain=1. ;
FILE *fopen();
FILE *fp;
float N_ratio ;
float noise_thresh_limit_dB=0. ;  

int track=1 ; 
int print_flag=0 ; 
char ch;
// SHELF EQ
float  dBlow=0, dBhi=0,  freqlow=200, freqhi=2000  ; 

float  temp,  temp2,  temp3,  temp4 ;  
float getthresh();
float   IR,  dur=0.;
int beginchan,  endchan ; 

float dBnumerator ; 
float fundamental, factor,   noisefiltergain,  filtamp ;  

float A_begint=0.,  A_endt=0. ; 
int A_method ; 

float sum_noise_amp,  frame_sum, trackampgain ; 

char tempstring[ 128 ] ; 

// COMB FREQUENCY SHIFT ADDER
struct  func  harmadd ; 

// GAIN
struct  func  dBgain ; 

// PITCH SEMITONE TRANSPOSE
struct  func  ptrans ; 


//  SOURCE DECIBELS
struct  func  noisethreshadjustdB ; 

//  ATTACK
struct  func  attack ; 

//  RELEASE
struct  func  release ; 


// NOISE EXPANSION INDEX
struct  func  expandex ; 


#include "underflow.h"


//*****************INITIALIZE
// COMB FREQUENCY SHIFT ADDER
harmadd.L = 1. ; harmadd.n = 1. ; harmadd.A[ 0 ] = 0. ; 

// GAIN
dBgain.L = 1. ;  dBgain.n = 1. ; dBgain.A[ 0 ] = 0. ; 

// PITCH SEMITONE TRANSPOSE
ptrans.L = 1. ; ptrans.n = 1. ; ptrans.A[ 0 ] = 0. ; 


//  SOURCE DECIBELS
noisethreshadjustdB.L = 1. ; noisethreshadjustdB.n = 1. ; noisethreshadjustdB.A[ 0 ] = 0. ; 

//  ATTACK
attack.L = 1. ; attack.n = 1. ; attack.A[ 0 ] = 0. ; 

//  RELEASE
release.L = 1. ; release.n = 1. ; release.A[ 0 ] = 0. ; 


// NOISE EXPANSION INDEX
expandex.L = 1. ; expandex.n = 1. ; expandex.A[ 0 ] = 3. ; 


if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|M|w|P|D|t|x|_|=|n|I|p|i|B|F|b|G|E|e|C|i|T|Q|Z|l|L|V|S|H|m|X|W|c|d|s|a|A|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'N':   N = atoi(arg_option);
			break;
	    case 'M':   Nw = atoi(arg_option);
			break;
	    case 'w':   window_type = atoi(arg_option) ;
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;
	    case 'I':   tfactor = atof(arg_option);
			break;

	    case 'P':   strcpy(tempstring, arg_option);
			ptrans.fp = crackstring( tempstring, &ptrans ); 
			break;
	    case 'a':   strcpy(tempstring, arg_option);
			harmadd.fp = crackstring( tempstring, 
			    &harmadd );
			break;
	    case 'A':   strcpy(tempstring, arg_option);
			dBgain.fp = crackstring( tempstring, 
			    &dBgain );
			break;

	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;



           case '_':	outputformat = atoi(arg_option) ; break;

           case '=':	rescalev = atof(arg_option) ; break;


	    case 'H':   dBlow = atof(arg_option) ;
			break;
	    case 'X':   dBhi = atof(arg_option) ;
			break;
	    case 'm':   freqlow = atof(arg_option) ;
			break;
	    case 'R':   freqhi = atof(arg_option) ;
			break;

            case 'p':	quiet = atoi(arg_option) ; break;
            case 'i':	ampstatinc = atof(arg_option) ; break;
            case 'Z':	print_flag = atoi(arg_option) ; break;


            case 'B':	A_begint = atof(arg_option) ; break;
            case 'E':	A_endt = atof(arg_option) ; break;
            case 'F':	A_method = atoi(arg_option) ; break;




	    case 'S':   strcpy(tempstring, arg_option);
			noisethreshadjustdB.fp = crackstring( tempstring, 
			    &noisethreshadjustdB );
			break;

	    case 'x':   strcpy(tempstring, arg_option);
			expandex.fp = crackstring( tempstring, 
			    &expandex );
			break;



            case 'Q':	noise_thresh_limit_dB = atof(arg_option) ; break;


	    case 'L':   strcpy(tempstring, arg_option);
			release.fp = crackstring( tempstring, 
			    &release );
			break;
	    case 'l':   strcpy(tempstring, arg_option);
			attack.fp = crackstring( tempstring, 
			    &attack );
			break;


	    case 't':   threshfacdB = atof(arg_option);
			break;
	    case 'h':	usage(1);
	}
    }

prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "NOISEFILTER", 69 ) ; 
prline( 69,  "-" ) ; 

    if(channelout == 0){
	channelflag = 0 ; 
	beginchan = 0 ;
    } else{
	channelflag = 1 ; 
	beginchan = channelout - 1 ; 
    }
 
// GET INPUT HEADER INFO AND SET UP OUTPUT FILE
    setupfiles(argc, argv) ; 

    endchan = beginchan + ochan ; 
    

// **** SET UPS *****
    R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    D = (int) ((float) R / frames_per_sec) ; 

    if(tfactor <= 0.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY A TIME FACTOR > 0. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 1.\n\n" ) ; 
	tfactor = 1. ; 
    }
    I = (int) ((float) D * tfactor ) ; 

//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
    if( Nw < I ){
	// INCREASE WINDOW SIZE TO ACCOMODATE INTERPOLATION
	Nw = 2 ; while( Nw <= I )Nw *= 2 ;
	prt( "\n----> INCREASING WINDOW SIZE TO ACCOMODATE TIME RESYNTHESIS INTERPOLATION. <---" ) ;
	pri( Nw,  "NEW WINDOW SIZE" ) ; 
    }

//*********************************
    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    nyquist = R/2.0;
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    IR = (float) I / (float) R ; 
    fundamental = (float) R / (float) N ; 
    factor = (float) R / ((float) D * TWOPI) ; 
    dBnumerator = (float) pow( (double) 10.0, (double) -3.9 ) ; 
    ar_dB =  (double) pow( (double) 10.0, (double) ( -60. / 20.) );	
    
    // COMPUTE THE DURATION
    dur = (endt - begint) * (float) I / (float) D ; 


// ******** FILTER FILE SETUPS
    if( A_endt <= 0. ) A_endt = idur ; 

// SET UP FLAG FOR OSCIL BANK OR OVERLAP/ADD
    if( 
	(ptrans.n  != 1.) || (harmadd.n  != 1.) || 
	    (ptrans.A[0] != 0.) || (harmadd.A[0] != 0.)  ) {
	// OSC BANK
	P = 1. ; obank = 1 ;  
    }else{
	// OVERLAPP-ADD
	P = 0. ; obank = 0 ;  
    }
    
//***************** PRINT VALUES
prf( dur, "OUTPUT FILE: DURATION" ) ; 
//*****************
prbanner( "FREQUENCY RESPONSE",  69 ) ; 
prline( 1,  "*" ) ; 
//*****************

prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
//pri( R,  "SAMPLE RATE" ) ; 

pri( frames_per_sec,  "FRAMES/SECOND" ) ; 
pri( tfactor,  "TIME EXPANSION/CONTRACTION FACTOR" ) ; 
prline( 1,  "*" ) ; 
pri( D,  "      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
pri( I,  "      INTERPOLATION SAMPLES (samples between resynthesis frames)" ) ; 
prline( 1,  "*" ) ; 
prf( threshfacdB, "OSCILLATOR RESYNTHESIS THRESHOLD (in dB)" ) ; 
prline( 1,  "*" ) ; 

prp( &dBgain,  "GAIN (in dB)"  ) ; 
prp( &ptrans,  "PITCH TRANSPOSITION (in semitones)"  ) ; 
prp( &harmadd,  "FREQUENCY SHIFT (in Hz)"  ) ; 
prline( 1,  "*" ) ; 
prp( &noisethreshadjustdB,  "NOISE THRESHOLD ADJUST (in dB)"  ) ; 
prline( 1,  "*" ) ; 
prp( &attack,  "ENVELOPE ATTACK TIME (in seconds)"  ) ; 
prp( &release,  "ENVELOPE RELEASE TIME (in seconds)"  ) ; 
prline( 1,  "*" ) ; 
prline( 1,  "*" ) ; 


prt( "*............. LOW/HIGH SHELF EQ............*" ) ;  
prf( freqlow, "LOW SHELF FREQUENCY" ) ; 
prf( dBlow, ".......... LOW SHELF DECIBELS" ) ; 
prf( freqhi, "HIGH SHELF FREQUENCY" ) ; 
prf( dBhi, ".......... HIGH SHELF DECIBELS" ) ; 
prt( "*...........................................*" ) ;  
prline( 1,  "*" ) ; 
// *******


//***************** SET UP ARRAYS


    
    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
    fvec( output, Nw ) ;	/* output buffer */
    fvec( amp_change, N2+2 ) ;	/* previous amplitude change for smoothing */
    fvec( previous_amp_change, N2+2 ) ;	/* previous amplitude change for smoothing */
    fvec( previous_channel, N+2 ) ;	/* previous analysis channels */

// MAKE THRESH AMP
    threshfac = pow( (double) 10.0, (double) (threshfacdB / 20.) );	

// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 

// ALLOCATE FILTER SPACE
fvec( F,  N+2  ) ;	/* filter array */


    if(dBlow != dBhi) prt("......USING SHELF EQ..............." ) ; 

//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(outchan = beginchan,  channow = 0; outchan < endchan; outchan++,  channow++ ){

prline( 69,   "=" ) ; 
pri( (outchan+1), "ANALYSIS: CHANNEL" ) ; 

 
// MAKE AN AVERAGE OR PEAK FREQRESPONSE
    make_freqresponse( F, Hwin, Wanal, Wsyn,   
    N, Nw, I, D, N2,  R, obank,   
    buffer, channel, input,   
    A_method,  A_begint,  A_endt ) ; 


// FIND THE AVERAGE AMPLITUDE
    sum_noise_amp = 0. ; 
    for( i = 0; i < N;  i += 2 ){
	sum_noise_amp += F[i] ; 
    }

//    if(print_flag)tprintspec( F, N, fundamental,  print_flag) ;

//    fprintf( stderr, "\n(OUT) noise_thresh_limit_dB = %f",  noise_thresh_limit_dB ) ; 

// SET TO ZERO THE BINS WHICH ARE MORE THAN THE THRESHOLD
    threshold_limit( F, N,  noise_thresh_limit_dB ) ;  


//*********** PRINT TO TERMINAL IF DESIRED ******
    if(print_flag)tprintspec( F, N, fundamental,  print_flag) ;

/*
prf( begint,	"INPUT FILE: BEGIN TIME" ) ; 
prf( endt,	"INPUT FILE: END TIME"	 ) ; 
prf( begin_sample,	"begin_sample" ) ; 
prf( end_sample,	"end_sample"	 ) ; 
prf( sample,	"sample"	 ) ; 
prf( ttlsamps,	"ttlsamps"	 ) ; 
pri( channow,	"channow"	 ) ; 
*/
    
    //*****   REINITS
    frame_count = 0 ;    eof = 0 ; 



    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;
	
//*********************************************
// LOOP FOR FRAMES
//*********************************************

    while ( !eof ) {
	in += D ;
	on += I ;
	timenow( dur ) ;
	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;
		  convert( buffer, channel, N2, D, R ) ;	 

	// SETUP PREVIOUS CHANNEL
	    if( !frame_count )for(i = 0; i < N; i++)
		    previous_channel[ i ] = channel[ i ] ; 

	// SETUP PREVIOUS AMP CHANGE FOR SMOOTHING
	    if( !frame_count )for(i = 0; i < N; i++)
		    previous_amp_change[ i ] = 1. ; 


//*************************
// GET THE VALUES
//*************************


//  SHIFT, GAIN, AND TRANSPOSITION

		harmadd.A[ 0 ] =  fval( &harmadd, dur, t );
		dBgain.A[ 0 ] =  fval( &dBgain, dur, t );
		ptrans.A[ 0 ] = fval( &ptrans, dur, t );
		    gain = dB_to_amp(dBgain.A[ 0 ] );	
		    pm = semitones_to_mult( ptrans.A[ 0 ] ) ;


		noisethreshadjustdB.A[ 0 ] = fval( &noisethreshadjustdB, dur, t );
		    noisefiltergain = dB_to_amp(noisethreshadjustdB.A[ 0 ] );

		expandex.A[ 0 ] = fval( &expandex, dur, t );




		attack.A[ 0 ] = fval( &attack, dur, t );
		smooth_setup( attack.A[ 0 ], &attackc, &minusattackc, IR ) ; 
		release.A[ 0 ] = fval( &release, dur, t );
		smooth_setup( release.A[ 0 ], &releasec, &minusreleasec, IR ) ; 



//*****************
// MODIFICATIONS LOOP
//*****************

    // FIND THE SUM OF THE FRAME'S AMPLITUDES
    frame_sum = 0. ; 
    for( i = 0; i < N; i+= 2 ) frame_sum += channel[ i ] ; 

/*
    if( (frame_sum > sum_noise_amp) )
	trackampgain =  sum_noise_amp / frame_sum ; 
    else
	trackampgain = 1. ; 
*/

		    // NOISE FILTERING
		    // MAKE AMP CHANGE MULTIPLIER FOR ALL BINS
		for( i = 0,  j = 0; i < N; i+= 2,  j++ ){
		    // MAKE THRESHOLD LEVEL AS MODIFIED BY THRESHOLD GAIN
		    temp2 = F[i] * noisefiltergain ; 
		    
		    // IF THRESHOLD IS > 0., THEN
		    if( temp2 > 0.  ){
			// IF AMP IS BELOW THRESHOLD, THEN
			if( channel[i] < temp2 ){

			    // MAKE AMP MULTIPLIER TO EXPAND OUT THE NOISE
			    // FIRST, MAKE FORM OF AMP NORMALIZED TO THRESHOLD
			    temp = channel[i] / temp2 ;
			     
			    // USE NORMALIZED AMP TO MAKE AMP MULTIPLIER (0-1)
			    amp_change[j] =  curve(0., 1., temp,  expandex.A[ 0 ]  );

			}else{
			    // AMP ABOVE THRESHOLD,  NO GAIN MULTIPLER
			     amp_change[j] = 1. ; 
			}
			// NOW SMOOTH THIS MULTIPLIER AGAINST PREVIOUS
		

		    }else{
			// THRESHOLD BELOW 0., NO GAIN MULTIPLER
			amp_change[j] = 1. ; 
		    }
		}
		
		// SMOOTH AMP CHANGE MULTIPLIERS
		smooth_amp_change( 
		    amp_change, previous_amp_change, N2, 
			attackc, minusattackc, releasec, minusreleasec ) ; 
		
		// NOW APPLY AMP CHANGES TO SPECTRUM
		for( i = 0,  j = 0; i < N; i+= 2,  j++ ) channel[ i ] *= amp_change[ j ] ; 

			

//*************EQ 
    eq( channel,  N,  dBlow,  dBhi, freqlow,  freqhi,  fundamental, 1,  0, 0 ) ; 


    // SMOOTH THE CHANGES TO THE SPECTRUM
//    smooth_zero( channel, previous_channel, N, attackc, minusattackc, releasec, minusreleasec, 
//			F, noisefiltergain ) ; 




	for( i = 1; i < N; i+= 2 ){

	    // SHIFT BY -a AND TRANSPOSE BY -P

	    temp = pm * (channel[i] + harmadd.A[ 0 ]) ;
		    
	    // ZERO BINS OUT OF 0-Nyquist FREQUENCY RANGE
	    if((temp <= 0.) || (temp >= nyquist)) channel[i - 1] = 0. ; 
	    else channel[i] = temp ; 
	    
	    channel[i - 1] = channel[i - 1] * gain ;  

	}
		

        synt = getthresh( channel, N, threshfac );

// ** OSCIL BANK OR OVERLAP/ADD OUT
	if ( obank ) {
	    noscbank(channel, N2, R, Nw, I, P, output);
	    shiftout( output, Nw, I, on+Nw-I, 0 ) ;
	} else {
	    unconvert( channel, buffer, N2, I, R ) ;

	    rfft( buffer, N2, INVERSE ) ;
	    overlapadd( buffer, N, Wsyn, output, Nw, on ) ;
	     shiftout( output, Nw, I, on, 0 ) ;
	
	}

	frame_count++ ; 

    // FRAMES LOOP END

    }
    // FLUSH OUT AND CLOSE OUTPUT FILE
    shiftout( output, Nw, I, 1, 1 ) ;

    
// CHANNELS LOOP END
} 

    // CLOSE  INPUT FILE
    fclose(ifd) ;  


    fprintf(stderr,"\n\nNOISEFILTER : RESYNTHESIS COMPLETED\n");
 
    if( harmadd.n != 1. ) fclose(harmadd.fp ) ;
    if( dBgain.n != 1. ) fclose(dBgain.fp ) ;
    if( ptrans.n != 1. ) fclose(ptrans.fp ) ;


   if( release.n != 1. ) fclose(release.fp ) ;
   if( attack.n != 1. ) fclose(attack.fp ) ;
   if( noisethreshadjustdB.n != 1. ) fclose(noisethreshadjustdB.fp ) ;

   if( expandex.n != 1. ) fclose(expandex.fp ) ;



    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"noisefilter:  phase vocoder spectrum remover \n"
	"noisefilter   [flags] [input file (16-bit shorts)] [output file (optional)]\n"
	"	    (values in brackets denote defaults)\n"
	"	N:	FFT length (must be a power of 2) [1024]\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	w:	window type: 0 = hamming,  1 = rectangular  \n"
	"		    2 = Blackman,  3 = Bartlett triangular [0.]\n"
	"	D:	analysis frames per second [200]\n"
	"	I:	time expansion/contraction factor  [1.] \n"
	"		  (duration = duration * factor, 1. = original time) \n"

	"	P:	pitch transposition in semitones (func) [0]\n"
	"	a:	frequency shift factor \n"
	"	A:	gain in decibels (func)[0.] \n"

	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (0. = end of file) [0.] \n"
	"	C:	resynthesis channel (1 -> ?) (0 = all) [0] \n"

	"	B:	NOISE RESPONSE ANALYSIS: begin time in seconds  [0.] \n"
	"	E:	NOISE RESPONSE ANALYSIS: end time in seconds (0. = end of file) [0.] \n"
	"	F:	NOISE RESPONSE ANALYSIS: method: 0 = average, 1 = peak  [0.] \n"
	"	Z:	NOISE ANALYSIS FREQUENCY RESPONSE PRINTOUT:\n"
	"		     high cutoff frequency in Hz (0 = off) [0]\n"



	"	S:	NOISE THRESHOLD ADJUST: gain in dB (func) [0.] \n"
	"		    Values > 0. increase the amount of noise reduction\n"
	"		    Values < 0. reduce the amount of noise reduction\n"
	"	x:	NOISE EXPANSION INDEX 0 - ? [3.] \n"
	"		    This value controls the shape of the expansion curve.\n"
	"		    The expansion is increased with greater values.\n"
	"	Q:	NOISE RESPONSE ANALYSIS: bypass threshold in dB [1.]\n"
	"		    ( Bins in the normalized noise response whose amp is greater \n"
	"			than the threshold are replaced with 0. letting \n"
	"			those frequencies pass when filtered. Set to 1. to \n"
	"			pass all frequencies through noise filter. )\n"

	"	l:      envelope attack time  (func) [0.]\n"
	"	L:      envelope release time   (func) [0.]\n"

	"	      SHELF EQ: (post-noise filtering,  pre-transposition/shift)\n"
	"	H:	SHELF EQ: Low shelf gain in dB [0.] \n"
	"	X:	SHELF EQ: High shelf gain in dB [0.] \n"
	"	m:	SHELF EQ: Low shelf frequency in Hz [200.] \n"
	"	R:	SHELF EQ: High shelf frequency in Hz [2000.] \n"

	"	p:	amplitude reports print mode: 0 = off, 1 = on [0]\n" 
	"	i:	time interval between amplitude reports [.25]\n" 
	"	_:	 OUTPUT FORMAT: 0 = taken from input file\n"
	"		    1 = 16-bit integer, 2 = 32-bit floats [0]\n" 

	"	=:	 PEAK RESCALE LEVEL (float output only) 0 to -96 dB \n"
	"		    set to 1 to rescale to level of input file [ 1 ]\n" 


	"	t:	oscillator resynthesis threshold in decibels [ -96 ]\n"
	);
    exit(woof);
}



int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }

