#include "globals.h"
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>

#define FREQUENCY_PROPORTION_THRESHOLD .99
#define BEGIN_T_FRAME_SIZE .05
#define MAX_T_FRAME_SIZE .3
#define NOTE_DB_THRESH -40
#define MAXIMUM_NUMBER_OF_FORMANTS 12
#define MINUMUM_FORMANT_DB -30


main( argc, argv )
    int argc ; char *argv[] ;
{
int i,j,  k, kk, kl=0,  i1,  i2,  mm ;
float nyquist,  fundamental;
double atof();
int R=44100, N=1024, N2, Nw = 2048, Nw2, D = 220, I = 220, in, on;
int   eof = 0, channelout=0,  chanmethod=0,  obank=0 ;
 float P = 1.0;
  FILE *fopen(), *fp,  *fofd,  *tof ;
char ch;
float *Hwin, *Wanal, *Wsyn, *input, *winput, *buffer, *channel,
    *channel_i,   *output ;
float	gain=1., peakamps[16]
 ;
float  temp,  temp2,  temp3, temp4, ftemp4,    old_temp=0.,  shortnorm ;  
float getthresh();
int beginchan,  endchan,  exflag=0 ; 
 
 int notestate_flag=0 , goodfreq,   backlogcount, bsize,   firstnote ; 
 
 float ampnow_out[ 2048 ],  a0,  a1 ; 
 
float peakbinamp = 0.,  avgbinamp=0.,  peakamp, peakenvamp=0., ampthresh,ampgatethresh,    limit ;
float   IR,  dur=0.;
char tempstring[ 128 ] ; 
FILE *famp,  *ffreq ; 
char  freqname[ 128 ],  ampname[ 128 ] ; 
float compression,  OR=44100.,  tp,  tpinc=500.,  freqdiff,  lowf,  hif ; 
float releasec,  minusreleasec,  attackc,  
    minusattackc,  freqchangec,  minusfreqchangec ; 
double ar_dB ;
int datatype=0 ;  
float frametprop,  tempt=0.,  midC ;
int qseccount=0,  seccount=0,  printflag=0 ;
int outtype=0 ; 
float snfloats[ 1000 ] ; 
short int shortsout[ 2000 ] ; 

int outsr ; 
int loc ; 
//*****************************
 float threshfac = .001;
 float maxigain;
float dfreqs[ 20 ],  maxamps[ 20 ]  ; 
float low_freq,  hi_freq,    maxbinfreq, smallestdifffreq, 
	smallestdifffreqavg=0.,  maxbinfreqavg=0.,  spectrumresfreqavg=0. , 
	    spectrumresfreq=0. ; 
float  peakpropthresh=.01, maxbinamp ;  


int fcount,  mflag,   median() ; 
float capacitance=0., cap,  invcapacitance=1.,  maxaverage=0.,  
    old_freqnow=-1.,  freqnow, fund,  resfreq   ;
int median_buffer_size=100,  mi=0 ; 
float *median_buffer,  med ; 

int *formants,   fsize, max_num_peaks=512, min_num_peaks=20, num_peaks,  *formant_freq_rank ; 
int num_formants=MAXIMUM_NUMBER_OF_FORMANTS ; 
float *formant_freq,  *formant_amp ; 

int zero_cross_peaks( float F[], float F_i[],   int N,  
	    int formant_bin[],  int NP,  int num_formants  
	    ) ;

int print_peak_freqs( float F[], float fundamental,  int N,  int formant_bin[], int B_num_peaks ) ; 

int find_formants( 
    float F[], 
    float fundamental,  
    int N,  
    int formant_bin[], 
    int num_peaks, 
    float formant_freq[],
    float formant_amp[], 
    int formant_freq_rank[]
     ) ; 


float find_freq_new( int detect_method, float  lowf, float hif, 
    float formant_freq[], float  formant_amp[],int formant_freq_rank[], int num_peaks ) ; 
    
//******************************

float find_freq() ; 

int begin_buffsize, 
    max_buffsize ; 

int extra_outs ; 

int nout=1, firstflag=0 ; 

float ampnow, old_ampnow,  fvalue,  avalue,  outval ; 
float	
	freqprop=FREQUENCY_PROPORTION_THRESHOLD, 
	tframe_size = BEGIN_T_FRAME_SIZE,  
	max_tframe_size = MAX_T_FRAME_SIZE, 	
	note_dBthresh = NOTE_DB_THRESH, 
	note_ampthresh ; 


float freqset=-1. ; 

float find_common_freq( 

    float freqprop, 
    float fbuff[],  
    float abuff[],  
    int max_buffsize,  
    int begin_buffsize, 
    float ampthresh  
    
    ) ; 
    
    
    
float norm_value( 

    float avalue,  
    float peakenvamp, 
    float compression, 
    float ampthresh, 
    float ampgatethresh, 
    float warp   
    ) ; 

int detect_method=0 ; 

int note_onoff,  ll,  outformat=0 ; 
float mindB=-80., noteondB=-50, noteonamp,  minamp ; 

float outfreqorigin=440,  asmooth=0.,  minusasmooth ;

float *fbuff,  *abuff ; 

float sine_wave( float freq,  int R ) ; 

// LOW FREQUENCY BOUND
struct  func  lowfreq ; 

//  HIGH FREQUENCY BOUND
struct  func  hifreq ; 


//  BIN AMP ENVELOPE RELEASE TIME
struct  func  release ; 

//  BIN AMP ENVELOPE RELEASE  TIME
struct  func  attack ; 

//  COMPRESSION
struct  func  compression_dB ; 

//  dB COMPRESSION THRESHOLD
struct  func  dBthreshold ; 

//  dB GATE THRESHOLD
struct  func  dBgate ; 

//  WARP
struct  func  warp ; 
	    
#include "underflow.h"

//*****************INITIALIZE
// LOW FREQUENCY BOUND
lowfreq.L = 1. ; lowfreq.n = 1. ; lowfreq.A[ 0 ] = 0. ; 

//  HIGH FREQUENCY BOUND
hifreq.L = 1. ; hifreq.n = 1. ; hifreq.A[ 0 ] = nyquist ; ; 


//  BIN AMP ENVELOPE RELEASE
release.L = 1. ; release.n = 1. ; release.A[ 0 ] = 0. ; 

//  BIN AMP ENVELOPE ATTACK
attack.L = 1. ; attack.n = 1. ; attack.A[ 0 ] = 0. ; 

//  DECIBELS OF COMPRESSION
compression_dB.L = 1. ; compression_dB.n = 1. ; compression_dB.A[ 0 ] = 1. ; 

//  COMPRESSION THRESHOLD IN DECIBELS
dBthreshold.L = 1. ; dBthreshold.n = 1. ; dBthreshold.A[ 0 ] = 0. ; 

//  GATE THRESHOLD IN DECIBELS
dBgate.L = 1. ; dBgate.n = 1. ; dBgate.A[ 0 ] = -96. ; 

//  WARP
warp.L = 1. ; warp.n = 1. ; warp.A[ 0 ] = 0. ; 



if( argc < 2 )usage(0) ; 


    while( (ch= crack( argc, argv, "R|N|M|P|D|g|j|J|t|I|m|b|Q|O|o|e|p|i|G|Z|X|S|f|F|L|l|d|s|a|A|C|T|W|n|B|X|r|p|Q|z|h", 0  )) != 0 ) {
	switch(ch) {
	    case 'N':   N = atoi(arg_option);
			break;
	    case 'M':   Nw = atoi(arg_option);
			break;
	    case 'D':   frames_per_sec = atof(arg_option);
			break;

	    case 'b':   begint = atof(arg_option) ;
			break;
	    case 'e':   endt = atof(arg_option) ;
			break;

	    case 'C':   channelout = atoi(arg_option) ;
			break;
	    case 'X':   chanmethod = atoi(arg_option) ;
			break;

	    case 'r':	tpinc = atof(arg_option);
			break;
	    case 'g':	outtype = atoi(arg_option);
			break;



	    case 'Q':	datatype = atoi(arg_option);
			break;

	    case 'm':	detect_method = atoi(arg_option);
			break;



	    case 'O':	outformat = atoi(arg_option);
			break;
	    case 'o':	outfreqorigin = atof(arg_option);
			break;

	    case 'j':	tframe_size = atof(arg_option);
			break;
	    case 'J':	max_tframe_size = atof(arg_option);
			break;
	    case 'd':	note_dBthresh = atof(arg_option);
			break;
	    case 'a':	asmooth = atof(arg_option);
			break;

	    case 'f':   strcpy(tempstring, arg_option);
			lowfreq.fp = crackstring( tempstring, 
			    &lowfreq );
			break;
	    case 'F':   strcpy(tempstring, arg_option);
			hifreq.fp = crackstring( tempstring, 
			    &hifreq );
			break;

	    case 'G':   strcpy(tempstring, arg_option);
			compression_dB.fp = crackstring( tempstring, 
			    &compression_dB );
			break;
	    case 'T':   strcpy(tempstring, arg_option);
			dBthreshold.fp = crackstring( tempstring, 
			    &dBthreshold );
			break;
	    case 'S':   strcpy(tempstring, arg_option);
			dBgate.fp = crackstring( tempstring, 
			    &dBgate );
			break;
	    case 'L':   strcpy(tempstring, arg_option);
			release.fp = crackstring( tempstring, 
			    &release );
			break;
	    case 'l':   strcpy(tempstring, arg_option);
			attack.fp = crackstring( tempstring, 
			    &attack );
			break;
	    case 'W':   strcpy(tempstring, arg_option);
			warp.fp = crackstring( tempstring, 
			    &warp );
			break;
	    case 'p':   printflag = atoi(arg_option) ;
			break;

	}
    }
 
prline( 69,  "/" ) ; 
prline( 69,  "-" ) ; 
prbanner( "AMPLITUDE ENVELOPE TRACKER", 69 ) ; 
prline( 69,  "-" ) ; 

    if( outtype == 2 ) tpinc = 44100. ; 
    
    minamp = pow( (double) 10.0, (double) (mindB/20.) );
    noteonamp = pow( (double) 10.0, (double) (noteondB/20.) );
    note_ampthresh = pow( (double) 10.0, (double) (note_dBthresh/20.) );
prf( note_ampthresh,  "note_ampthresh" ) ; 
    note_onoff = 0 ; 

    if(channelout == 0){
	channelflag = -2 ; 
	beginchan = 0 ;
    } else{
	channelflag = 1 ; 
	beginchan = channelout - 1 ; 
    }

if( (outtype == 0) ||  (outtype == 1)){
    // SET NO OUTPUT FLAG
    outputoff=1;
}else if(outtype == 2){
    outputoff=0;
}else{
    fprintf( stderr,"\n\nUNKNOWN OUTPUT DATA TYPE!\n\n") ; exit(0) ;  
}

    pri( outputoff,  "outputoff" ) ;  
    setupfiles(argc, argv) ; 
    endchan = beginchan + ochan ; 
/******
 
 
*******/
   
if( (outtype == 0) ||  (outtype == 1) ){
    // GET NAME OF OUTPUT FILE
    arg_index++ ; 
fprintf( stderr, "\nWORD:    %s\n",  argv[ arg_index ] ) ; 
    if( arg_index >= argc  ){
	bannero() ;
	ofile =  "envelope.out" ; 
	fprintf( stderr, "\n\n.....().USING DEFAULT OUTPUT FILENAME........\n\n" ) ;

	fprintf( stderr,  "\n\nOUTPUT FILE: %s\n",  ofile ) ; 
    }else{
    // GET OUTPUT FILE NAME
	ofile = argv[arg_index] ; 
    }	 
    // ASCII OR HEADERLESS FLOAT OUTPUT
    fofd = fopen( ofile,  "w" ) ;     

}else{
    // SOUNDFILE OUTPUT

}


// **** SET UPS *****
    R = isr ; // SAMPLE RATE EQUALS INPUT FILE
    if( frames_per_sec < 32.){
	fprintf( stderr, "\n\n----> YOU MUST SPECIFY 32 OR MORE FRAMES PER SECOND. <-----" ) ; 
	fprintf( stderr, "\n.............RESETING TO DEFAULT OF 200.\n\n" ) ; 
	frames_per_sec = 200 ; 
    }
    I = D = (int) ((float) R / frames_per_sec) ; 
//*****
//******  WINDOW SETUP/ADJUSTMENT ***************************
// MAKE WINDOW SIZE TWICE FFT IF SET TO 0
    if( Nw <= 0 ) Nw = 2 * N ;
//*********************************

 if( tpinc < frames_per_sec ){
     // CHANGE IT
     prt( ".....YOUR OUTPUT ENVELOPE SAMPLE RATE IS < THE FRAMES PER SECOND." ) ; 
     prf( frames_per_sec,  " WILL CHANGE TO THE FRAMES PER SECOND RATE " ) ;
     tpinc =  1.  ; 
 }else{
     prf( tpinc, "OUTPUT ENVELOPE SAMPLES PER SECOND" ) ; 
     tpinc = 1. / (tpinc  / frames_per_sec)  ; 
 }
if( tpinc > 1. ){
    fprintf( stderr,  "\n\nSAMPLES PER OUTPUT FRAME MUST BE >= 1. BYE.\n" ) ;
    exit(0);
}
// MAKE /tmp ENVELOPE SCRATCH SPACE
// MAKE UNIQUE NAME
// OPEN IT

    srandom( time(0) ) ; 
    sprintf( ampname, "/tmp/envelope.%d", (int)(random()) ) ;
    famp = fopen( ampname, "w+" ); //AMP
    sprintf( freqname, "/tmp/pitch.%d", (int)(random()) ) ;
    ffreq = fopen( freqname, "w+" ); //FREQ

    IR = (float) I / (float) R ; 
    
    PI = 4.*atan(1.) ;
    TWOPI = 8.*atan(1.) ;
    obank = P != 0. ;
    if( P == 0.0 ) {P = 1.0;}
    N2 = N>>1 ;
    Nw2 = Nw>>1 ;
    freqdiff = (float) R / (float) N  ;
    nyquist = (float) R / 2.0;
    ar_dB =  (double) pow( (double) 10.0, (double) ( -60. / 20.) );	
    fundamental =  ((float) R / (float) N) ; 
    frametprop = (float) D / (float) R ; 
    midC = (220.*pow(2., (3./12.))) ; 

    // COMPUTE THE DURATION
    dur = (endt - begint) ; 

    // RECOMPUTE FOR INTERPOLATION
    if(asmooth <= 0.){
	asmooth = 0. ; minusasmooth = 1. ; 
    }else{
	// LOWPASS
	 asmooth = pow( (double) ar_dB,  
			    (double) (IR / asmooth ) ) ; 
		    minusasmooth = 1.  - asmooth ; 
		}


//***************** PRINT VALUES
prbanner( "ANALYSIS PARAMETERS",  69 ) ; 
pri( N,  "FFT SIZE" ) ; 
prline( 1,  "*" ) ; 
prf( fundamental, "      FUNDAMENTAL ANALYSIS FREQUENCY" ) ; 
prline( 1,  "*" ) ; 
pri( Nw,  "WINDOW SIZE" ) ; 
prline( 1,  "*" ) ; 
pri( frames_per_sec,  "FRAMES/SECOND" ) ; 
prline( 1,  "*" ) ; 
pri( D,  "      DECIMATION SAMPLES (samples between analysis frames)" ) ; 
prline( 1,  "*" ) ; 
pri( datatype, " BOUNDARY DATA TYPE" ) ; 
if( !datatype ){
    prp( &lowfreq,  "LOW FREQUENCY  BOUNDARY" ) ;  
    prp( &hifreq,  "HIGH FREQUENCY  BOUNDARY" ) ;  
}else{
    prp( &lowfreq,  "LOW OCTAVE.PITCHCLASS  BOUNDARY" ) ;  
    prp( &hifreq,  "HIGH OCTAVE.PITCHCLASS  BOUNDARY" ) ;  
}

prline( 1,  "*" ) ; 
prp( &release,  "ENVELOPE RELEASE TIME" ) ;  
prp( &attack,  "ENVELOPE ATTACK TIME" ) ;  
prline( 1,  "*" ) ; 
prp( &dBthreshold,  "COMPRESSION THRESHOLD (in decibels)" ) ;  
prp( &compression_dB,  "AMOUNT OF COMPRESSION (in decibels)" ) ;  
prp( &dBgate,  "GATE THRESHOLD (in decibels)" ) ;  
prline( 1,  "*" ) ; 
prf( outformat, "OUTPUT FORMAT CODE" ) ; 
prf( outfreqorigin,  "REFERENCE FREQUENCY" ) ; 

prp( &warp,  "WARP SHAPE INDEX" ) ;  
	    
if( outtype == 0 )
    prt("OUTPUT WILL BE ASCII............" ) ;
else  if( outtype == 1 )
    prt("OUTPUT WILL BE FLOATS............" ) ;
else if( outtype == 2 )
    prt("OUTPUT WILL BE NEXT SOUNDFILE............" ) ;
else
    {
    prt("NOT A RECOGNIZED OUTPUT FORMAT FLAG. BYE!\n\n" ) ; exit( 0 ); 
    }
if( ochan > 1 ){
    if( !chanmethod )prt(".................USING AVERAGE METHOD" ) ;
    else prt(".................USING PEAK METHOD" ) ;
}

// *******

    if (Nw == 0) Nw = N;

    if (I == 0) I = D;


// *******

    fvec( Wanal, Nw ) ;		/* analysis window */
    fvec( Wsyn, Nw ) ;		/* synthesis window */
    fvec( input, Nw ) ;		/* input buffer */
    fvec( Hwin, Nw ) ;		/* plain Hamming window */
    fvec( winput, Nw ) ;	/* windowed input buffer */
    fvec( buffer, N ) ;		/* FFT buffer */
    fvec( channel, N+2 ) ;	/* analysis channels */
   fvec( channel_i, N+2 ) ;	/* extra for formant search */

    fsize = 1 + (num_formants * 2) ; 
    ivec( formants, fsize ) ;	// MODEL FORMANT INDECES ARRAY

    fvec( formant_freq, num_formants ) ; 
    fvec( formant_amp, num_formants ) ; 
    ivec( formant_freq_rank, num_formants ) ; 
 
    fvec( output, Nw ) ;	/* output buffer */

   fvec( median_buffer, median_buffer_size ) ;	/* median_buffer */


// OPEN INPUT  AND OUTPUT FILES
    openfiles() ; 

//*********************************************
// LOOP FOR CHANNELS
//*********************************************

for(outchan = beginchan,  channow = 0; outchan < endchan; outchan++,  channow++ ){

prline( 69,   "=" ) ; 
pri( (outchan+1), "ANALYSIS: CHANNEL" ) ; 

    //*****   REINITS
    frame_count = 0 ;    eof = 0 ; 
    tempt = 0. ; qseccount=0 ;  seccount=0 ; 
    peakamps[channow] = 0 ; backlogcount = 0 ;  

    rewind( famp ) ; 
    rewind( ffreq ) ; 

    makewindows( Hwin, Wanal, Wsyn, Nw, N, I, obank ) ;
    in = -Nw ;
    if ( D )
	on = (in*I)/D ;
    else
	on = in ;
	
   	
//*********************************************
// LOOP FOR FRAMES
//*********************************************

    while ( !eof ) {
 
	in += D ;
	on += I ;
	timenow( dur ) ;

	 	  eof = shiftin( input, Nw, D ) ;
	  	  fold( input, Wanal, Nw, buffer, N, in ) ;
	  	  rfft( buffer, N2, FORWARD ) ;
	  	  convert( buffer, channel, N2, D, R ) ;

//*************************
// GET THE VALUES
//*************************
		lowfreq.A[ 0 ] = fval( &lowfreq, dur, t );
		hifreq.A[ 0 ] = fval( &hifreq, dur, t );



		release.A[ 0 ] = fval( &release, dur, t );
		// RECOMPUTE FOR INTERPOLATION
		if(release.A[ 0 ] <= 0.){
		    releasec = 0. ; minusreleasec = 1. ; 
		}else{
		    // LOWPASS
		    releasec = 
			pow( (double) ar_dB,  
			    (double) (IR / release.A[ 0 ] ) ) ; 
		    minusreleasec = 1.  - releasec ; 
		}

		attack.A[ 0 ] = fval( &attack, dur, t );
		if(attack.A[ 0 ] <= 0.){
		    attackc = 0. ;  minusattackc = 1. ;
		}else{
		    // LOWPASS
		    attackc = 
			pow( (double) ar_dB,  
			    (double) (IR / attack.A[ 0 ] ) ) ; 
		    minusattackc = 1.  - attackc ; 
		}


//*************************


// TURN PITCH BOUNDS INTO FREQ

	    if( datatype ){
		// OCTAVE.PITCHCLASS
		if( fabs( (double) lowfreq.A[ 0 ] ) > 15. ){
		    // QUESTIONABLE
		    prf( lowfreq.A[ 0 ],  "\n\n ====> QUESTIONABLE OCTAVE.PITCHCLASS LOW BOUNDARY" ) ; 
		    prt( "QUESTIONABLE DATA.............................." ) ; 
		    exflag = 1 ;  
		} 
		if( fabs( (double) hifreq.A[ 0 ] ) > 15. ){
		    // QUESTIONABLE
		    prf( hifreq.A[ 0 ],  "\n\n ====> QUESTIONABLE OCTAVE.PITCHCLASS HIGH BOUNDARY" ) ; 
		    prt( "QUESTIONABLE DATA.............................." ) ; 
		    exflag = 1 ;  
		} 
		if( exflag ){
		    prt( "\n\nIS YOUR DATA TYPE FLAG CORRECT?\n\n.......CHECK YOU DATA.\n\n" ) ; 
		    exit(0) ; 
		}
		// TURN INTO FREQ
		if( lowfreq.A[ 0 ] < 3.){
		    lowf = 0;
		}else{
		    lowf = (float) ((int) lowfreq.A[ 0 ] ) ; // INTEGER PART
		    lowf =  (( 12. * (lowf - 8.)) + 
			(100. * (lowfreq.A[ 0 ] - lowf)) ) / 12. ;
		    lowf = midC * pow( 2., (double) lowf ) ; 
		}

		if( hifreq.A[ 0 ] < 3.){
		    hif = nyquist;
		}else{
		    hif = (float) ((int) hifreq.A[ 0 ] ) ; // INTEGER PART
		    hif =  (( 12. * (hif - 8.)) + 
			(100. * (hifreq.A[ 0 ] - hif)) ) / 12. ;
		    hif = midC * pow( 2., (double) hif ) ; 
		}


	    }else{
		// FREQ
		if( (hifreq.A[ 0 ] < 15.) ){
		    prt("\n\n ====> QUESTIONABLE FREQUENCY  BOUNDARIES\n\n" ) ; 
		    exflag = 1 ;  
		}else{
		    lowf = lowfreq.A[ 0 ]; 
		    hif = hifreq.A[ 0 ] ; 
		}
	    }

		if( exflag ){
		    prt( "\n\nIS YOUR DATA TYPE FLAG CORRECT?\n\n.......CHECK YOU DATA.\n\n" ) ; 
		    exit(0) ; 
		}

// STUPIDITY TEST
    if( lowf < 0. ) lowf = 0. ; 
    if( hif > nyquist ) hif = nyquist ; 




// TURN FREQ BOUNDS INTO INDECES


		i1 = 1 +  (int) ( 2. * (int) ( lowf / freqdiff ) ) ; 
		i2 = 1 +  (int) ( 2. * (int) ( hif / freqdiff ) ) ; 


//*****************
// MODIFICATIONS LOOP
//*****************


    //*************WARP THE INPUT SPECTRUM
   //spectmagwarp( channel,  N, 20., 0 ) ;		


// SMOOTH THE SPECTRUM TO HELP THE FORMANT SEARCH
    //smoothspec( channel, N2, .1, R ) ;


// FIND FORMANT BIN VALLEYS AND PEAKS
	num_peaks = zero_cross_peaks( channel,  channel_i,  N,  
			formants, fsize, num_formants  ) ;

//prline( 69,   "=" ) ; 

// USING THE VALLEY MARKERS, FIND THE FORMANT FREQUENCIES
    find_formants( channel,fundamental,  N,  formants, num_peaks, 
			formant_freq,  formant_amp, formant_freq_rank ) ; 


// PRINT THE FORMANTS
   //print_peak_freqs( channel, fundamental, N,  formants, num_peaks ) ;  


	// FIND THE FREQ

	if( (detect_method == 0 ) || (detect_method == 1 ) ){
	    // HARMONIC COLLECTION OR STRONGEST FORMANT
	    freqnow = find_freq_new( detect_method,  lowf,  hif,
		formant_freq,  formant_amp, formant_freq_rank,  num_peaks ) ;  

	}else if( detect_method == 2 ){
	    // CENTROID
	    freqnow = find_centroid( channel, N, lowf, hif, fundamental, &old_freqnow ) ;

	}else{
	    // BOGUS
	    pri( detect_method,  "DETECTION METHOD" ) ;
	    prt( " IS NOT ONE OF THE METHODS. BYE."); 
	    exit(0); 
	}
prf( freqnow,  "FREQUENCY" ) ; 

    // USE OLD IF AMP WAS 0. 
    if( freqnow <= 0. )  freqnow = old_freqnow ; 
 


// ENVELOPE: SUM THE BIN AMPS BETWEEN THE BOUNDS
		temp = 0 ; 

		for( i = i1; i <= i2; i += 2){
		     temp += channel[i - 1] ; 
		}
		

		//SMOOTH IT 
		if(temp > old_temp){ //ATTACK
		    temp = (attackc * old_temp) +
			(minusattackc * temp) ; 
		} else { // DECAY
		    temp = (releasec * old_temp) +
		    (minusreleasec * temp) ; 
		}
		old_temp = temp ; 
		
		if( peakenvamp < temp ) peakenvamp = temp ; 

// OUTPUT THE AMPLITUDE 
	    if( channow == 0 ){
    		// WRITE FIRST CHANNEL
		fwrite( &temp, sizeof(float), 1, famp );
	    }else{
		loc = ftell( famp ) ; 
		// READ IN VALUE
		fread( &temp2, sizeof(float) , 1, famp ) ; 

		if( !chanmethod ){ 
		    // TAKE AVERAGE
		    temp = ((( (float) channow / (float) (channow + 1) )
			* temp2 ) + temp ) / (float)  (channow + 1) ; 
		}else{
		    // TAKE PEAK
		    if( temp2 > temp ) temp = temp2 ; 
		}
		
		fseek( famp, loc,  SEEK_SET ) ; 

		fwrite( &temp, sizeof(float), 1, famp );
	    }		

// ************** FREQUENCY
// OUTPUT THE FREQUENCY 
	    if( channow == 0 ){
    		// WRITE FIRST CHANNEL
		fwrite( &freqnow, sizeof(float), 1, ffreq );
	    }else{
		loc = ftell( ffreq ) ; 
		// READ IN VALUE
		fread( &temp2, sizeof(float) , 1, ffreq ) ; 

		if( !chanmethod ){ 
		    // TAKE AVERAGE
		    freqnow = ((( (float) channow / (float) (channow + 1) )
			* temp2 ) + freqnow ) / (float)  (channow + 1) ; 
		}else{
		    // TAKE PEAK
		    if( temp2 > freqnow ) freqnow = temp2 ; 
		}

		fseek( ffreq, loc,  SEEK_SET ) ; 
		fwrite( &freqnow, sizeof(float), 1, ffreq );
	    }		
// *********************

// *** 
// *** PASSIFIER PRINT
    if(printflag != 0){
	if(!frame_count)fprintf( stderr,  "\n\nELAPSED TIME (in secs): 0 " ) ; 

	tempt = tempt + frametprop ; 
	if(tempt > .25){
	    // PRINT PASSIFIER
	    qseccount++ ; 
	    while( tempt > .25 ) tempt -= .25 ; 
	    if( qseccount == 4){
		// SECOND
		seccount++ ;  qseccount = 0 ; 
		fprintf( stderr, " %d ",  seccount ) ; 
	    }else{
		// QUARTER SECOND
		fprintf( stderr,  "*" ) ; 
	    }
	    
	}
    }
// *** 
	frame_count++ ; 

// FRAMES LOOP END
    }
    

    fclose( famp ) ; 
    fclose( ffreq ) ; 


//prf( peakenvamp,  "peakenvamp" ) ; 
// CHANNELS LOOP END
} 


// ********************************* NOW OPEN, COMPRESS AND NORMALIZE
    

    fprintf( stderr," \nNORMALIZING, THE SIGNAL......" ) ;   
    ochan = 1 ; 
    frame_count = 0 ; 
    notestate_flag = 0 ; backlogcount = 0 ; firstnote = 1 ;  
    ampnow_out[ 0 ]  = 0. ; 

// OPEN IT
    famp = fopen( ampname, "r" ); //AMP
    ffreq = fopen( freqname, "r" ); //FREQ
    kk = 11025 ; kl = 0 ; 
    fprintf( stderr,  "\n\n" ) ; 
    shortnorm = 1. - (1./32760.) ;   
    eof = 0 ; mm = 0 ; 
    tp = 0 ; 
	// MAKE BEGINNING BUFFER SIZE, IF LESS THAN 6 MAKE IT 6
    begin_buffsize = (.5 + tframe_size * (float) frames_per_sec) ;
    if( begin_buffsize < 6 ) begin_buffsize = 6 ; 
	// MAKE MAX BUFFER SIZE, IF LESS THAN 6 MAKE IT 6
     max_buffsize =  (.5 + max_tframe_size * (float) frames_per_sec) ;
    if( max_buffsize < 12 ) max_buffsize = 12 ; 

    fvec( fbuff,  max_buffsize ) ; 
    fvec( abuff,  max_buffsize ) ; 
    

// FILL FREQ  BUFFER
	i = fread( &fbuff[ 0 ], sizeof(float) , 1, ffreq ) ;
	for( j = 1 ; j < max_buffsize; j++ ) fbuff[ j ] = fbuff[ 0 ] ; 

	i = fread( &abuff[ 0 ], sizeof(float) , (max_buffsize - 1), famp ) ; 	
	for( j = 1 ; j < max_buffsize; j++ ) abuff[ j ] = abuff[ 0 ] ; 

/*
	i = fread( &fbuff[ 1 ], sizeof(float) , (max_buffsize - 1), ffreq ) ; 	
	    
	if( i < (max_buffsize - 1) ){
	    // NOT ENOUGH TO EVEN FILL BUFFER
	    fprintf( stderr, "\n\nNOT ENOUGH FRAMES TO EVEN FILL ONE BUFFER!\n\n" ) ;
	    max_buffsize = i ; 
 	}   


	i = fread( &abuff[ 1 ], sizeof(float) , (max_buffsize - 1), famp ) ; 	

	if( i < (max_buffsize - 1) ){
	    // NOT ENOUGH TO EVEN FILL BUFFER
	    fprintf( stderr, "\n\nNOT ENOUGH FRAMES TO EVEN FILL ONE BUFFER!\n\n" ) ;
	    max_buffsize = i ; 
 	}   

*/

//** BEGIN OF OUTPUT LOOP

   while ( max_buffsize > 6  ){

	    //*************************************************
	    	  
		  
	    // GET SOME CONTROL VALUES
	      	
	    t =  (float) frame_count * IR  ; // TIME
	    compression_dB.A[ 0 ] = fval( &compression_dB, dur, t );
	    if( compression_dB.A[ 0 ] < 0. )
		compression = pow( (double) 10.0, (double) (compression_dB.A[ 0 ]/20.) );
	    else
		compression = 1. ; 

	    dBthreshold.A[ 0 ] = fval( &dBthreshold, dur, t );
		ampthresh = pow( (double) 10.0, (double) (dBthreshold.A[ 0 ]/20.) );	

	    dBgate.A[ 0 ] = fval( &dBgate, dur, t );
		ampgatethresh = pow( (double) 10.0, (double) (dBgate.A[ 0 ]/20.) );	

	    if( ampthresh <= ampgatethresh ){
		// TROUBLE
		prt( "\n\nYOUR GATE THRESHOLD IS BELOW YOUR COMPRESSION THRESHOLD.\n\n.....BYE.\n\n" ) ; 
		exit(0) ; 
	    }

	    warp.A[ 0 ] = fval( &warp, dur, t );

	    //*************************************************


	    if( frame_count == 0 ){
		// NORMALIZE
		for( i = 0; i < max_buffsize; i++ )
		    abuff[ i ] = norm_value( abuff[ i ], peakenvamp,  compression, 
			ampthresh, ampgatethresh,  warp.A[ 0 ]   ) ; 
//	    prf( abuff[ i ],  "abuff[ i ]" ) ; 
	    }

	    //*************************************************
	    // READ IN A FREQ AND AMP VALUE
	    if( fread( &fvalue, sizeof(float), 1, ffreq ) == 0 )  eof = 1 ; 
	    if( fread( &avalue, sizeof(float), 1, famp  ) == 0 )  eof = 1 ; 

	    avalue = norm_value( avalue, peakenvamp,   compression, 
			ampthresh, ampgatethresh,  warp.A[ 0 ]   ) ; 

	    // IF WE HAVE NOT HIT THE END, THEN....
	    if( !eof ){

		    // SHIFT AND ADD TO BUFFERS
		    // FIRST SHIFT ALL THE OLD BY ONE
		    for( ll = max_buffsize - 1 ; ll > 0 ; ll-- ){ 
			fbuff[ ll ] = fbuff[ ll - 1 ] ;
			abuff[ ll ] = abuff[ ll - 1 ] ;
		    }
		    // FILL 0 LOCATION WITH NEW VALUE. 
		    fbuff[ 0 ] = fvalue ; abuff[ 0 ] = avalue ;
		    

	    }else{
		    // HIT THE END. DECREMENT MAX SIZE AND
		    max_buffsize-- ; 
		    // SHIFT VALUES TOWARDS BEGIN
		    for( ll = 0 ; ll > max_buffsize ; ll++ ){ 
			fbuff[ ll ] = fbuff[ ll + 1 ] ;
			abuff[ ll ] = abuff[ ll + 1 ] ;
		    }
		    
		    // IF THE FULL (MAX) BUFFER SIZE HAS DIMINISH BELOW BEGIN SIZ
		    // MAKE THE BEGIN THE SAME AS THE MAX
		    if( begin_buffsize > max_buffsize ) 
				begin_buffsize = max_buffsize ; 
	    }

 
 	    // MAKE THE CURRENT AMP EQUAL THE HEAD OF THE AMP BUFFER
	   ampnow = abuff[0] ; 

// prf( ampnow,  "ampnow" ) ; 
       
// ***************** FREQ AND AMP OUT *********************
	    // ************ FREQ FINDING SECTION **********
	    // FIND THE MOST COMMON VALUE IN THE BUFFER

	    if( frame_count == 0 ) {
		// IF THE FIRST FRAME, SET OLD FREQ TO MIDWAY BETWIXT THE BOUNDS
		if( old_freqnow == -1. ) old_freqnow = lowf + .5 * (hif - lowf ) ; 
	    }
//prf( t,  "TIME" ) ; 
	    // HERE GOES... FIND THE MOST COMMON FREQ IN BUFFER
	    // (freqprop IS THE THRESHOLD OF COMMONMESS PROPORTION DEFINED UP TOP
	    freqnow = find_common_freq( freqprop, fbuff, abuff, max_buffsize,  begin_buffsize,  note_ampthresh ) ; 
//prf( freqnow,  "                          NOTE FREQUENCY" ) ; 



//pri( notestate_flag,  "notestate_flag" ) ; 
//prf( freqnow,  "NONADJUSTED FREQ" ) ; 
//prf(ampnow,  "ampnow" ) ; 
	    // AMP THRESHOLD ADJUSTMENTS
	    if(  ( ampnow < note_ampthresh ) ){

		if( firstnote ){

//prt( "// FIRST NOTE AND NO AMP. NOT A GOOD FREQ." )  ; 
			// FIRST NOTE AND NO AMP. NOT A GOOD FREQ. 
			goodfreq = 0 ; 

		}else{
		    // NOT THE FIRST NOTE
		    
//prt( " BELOW AMP THRESHOLD AND NOT FIRST NOTE, USE OLD" ) ; 
		    //***  BELOW AMP THRESHOLD  USE OLD
		     freqnow = old_freqnow ;
		    // NOW IT IS A GOOD FREQ
		     goodfreq = 1 ; 
		    
		}
		    
	    }else{
		
		
		//**** ABOVE AMP TRHESHOLD

		if( (freqnow < lowf) || (freqnow > hif) ){
		
		    //*** OUT OF BOUNDS FREQ

		    if( notestate_flag && goodfreq ){ 

//prt( "// NOTE IS ALREADY ON AND WE HAD A GOOD FREQ, USE OLD VALUE" ) ; 

			// NOTE IS ALREADY ON AND WE HAD A GOOD FREQ, USE OLD VALUE
			freqnow = old_freqnow ;
			// OLD VALUE HERE IS A GOOD FREQ 
			 goodfreq = 1 ; 

		    }else{
			// NOTE HAS BEEN OFF. NOT A GOOD FREQ. 
			goodfreq = 0 ; 

//prt( "// NOTE HAS BEEN OFF. NOT A GOOD FREQ." ) ; 
		     
		    }

		}else{
//prt( "// IN BOUNDS FREQ,  A GOOD FREQ" ) ; 
		    // IN BOUNDS FREQ,  A GOOD FREQ
		     goodfreq = 1 ; 
		}
	    
	    }

//prf( freqnow,  "ADJUSTED FREQ" ) ; 


	// SET notestate_flag FOR NEXT ROUND
	if(ampnow >= note_ampthresh) notestate_flag = 1; 
	else notestate_flag = 0 ; 

	// INCREMENT backlogcount
	backlogcount++ ; 






//fprintf( stderr,  "\ntime: (%f) ampnow = %f,  note_ampthresh = %f, old_freqnow = %f,   freqnow = %f", 
//		(float) frame_count * IR, ampnow, note_ampthresh,  old_freqnow,    freqnow  ) ; 


	    // ************ 


//pri( goodfreq,  "BEFORE OUTPUT ROUTINE: goodfreq" ) ; 
//pri( backlogcount,  "BEFORE OUTPUT ROUTINE:backlogcount" ) ; 



    // INSERT NEW
    ampnow_out[ backlogcount ] = ampnow ; 


    // GOOD FREQ ROUTINE
     if( goodfreq == 1  ){

	if( firstnote ){
	    // FIRST NOTE, USE freqnow FOR old_freqnow AND FLIP firstnote
	    old_freqnow = freqnow ; 
	    firstnote = 0 ; 
	}





	  // LOOP FOR BACKLOG
	  // SAVE backlogcount SIZE
	  bsize = backlogcount ; 
	  
	  
	  
	  while( backlogcount > 0 ){
// pri( backlogcount,  "IN ROUTINE LOOP:backlogcount" ) ; 

		
	    // SMOOTH FREQ VALUE
		freqnow = (asmooth * old_freqnow) +
		    (minusasmooth * freqnow) ; 


		a0 = ampnow_out[bsize - backlogcount] ; 
		a1 = ampnow_out[bsize - backlogcount + 1] ; 
		 

		while( tp < 1. ){
		    // AMP VALUE
		    temp4 = 
			curve( a0,  a1 ,  tp,  0.  ) ;
		    if( temp4 >= 1. )temp4 = shortnorm ;  
		    // FREQ
		    ftemp4 = curve( old_freqnow,  freqnow,  tp,  0.  ) ;
	
		    if( outformat == 0 ){
			// FREQ
			outval = ftemp4 ; 
		    
		    }else if( outformat == 1 ){
			// O.DECIMAL
			outval = 8.0 + ( log10( ftemp4 / 261.625 ) / log10( 2.0 )) ;
		    }else if( outformat == 2 ){
			// SEMITONES OF DEVIATION 
			    outval = 12. * log10(ftemp4 / outfreqorigin) / log10( 2.0 ) ; 	    
		    }else if( outformat == 3 ){
			// SEMITONES OF DEVIATION 
			    outval = - (12. * log10(ftemp4 / outfreqorigin) / log10( 2.0 )) ; 	    
		    }else {
			fprintf( stderr, "\n\nNOT AN ACCEPTED OUTPUT FORMAT!" ) ; 
		    }
		    if( outtype == 0 ){
			fprintf( fofd, "%f\n",  outval ) ;
		    }else  if( outtype == 1 ){
			fwrite( &outval, sizeof(float), 1,   fofd ) ;
		    }else{
			// NEXT SOUNDFILE
	
				// FILL ARRAY
				shortsout[ (kl * 2) ]  = (int) (32768. * (ftemp4 - lowf) / (hif - lowf) ) ; 
				shortsout[ (kl * 2) + 1 ]  = (int) (temp4 * 32768. * sine_wave( ftemp4,  R ) ) ; 
				kl++ ; 
				if( kl >= 1000 ){
				    // NOW WRITE OUT ARRAY
				    write( ofd,  &shortsout, (2000 * sizeof(short)) ) ;
				    kl = 0 ; 
				}
		    }
		
		    mm++ ; 
		    tp = tp + tpinc ;
	
			// PASSIFIER PRINT
			if( kk < 0 ){
			    fprintf( stderr, " * " ) ; kk = 11025 ; 
			}
	
			kk-- ; 
		}
    
		old_freqnow = freqnow ; 
		tp = tp - (float) ((int) tp ) ; 
	
	
		    // DECREMENT backlogcount
		    backlogcount-- ; 
    
	 // END OF LOOP FOR BACKLOG OUTPUT
	 }


	// PUT ampnow IN FIRST LOCATION
	ampnow_out[ 0 ] = ampnow ; 


   // END OF GOOD FREQ ROUTINE
   }



	// INCREMENT FRAME COUNT
      frame_count++ ; 


    // OUTPUT LOOP END
   }





    // DUMP REMAINDER
    if( kl > 0 ) write( ofd,  &shortsout, (kl * 2 * sizeof(short)) ) ;
	    

    
    fclose( famp ) ;
    fclose( ffreq ) ;
    // CLOSE INPUT FILES
    fclose(ifd) ;  

    // CLOSE  OUTPUT  FILES
    if( (outtype == 0) ||  (outtype == 1) ){
	fclose(fofd) ; 
    }else  if( outtype == 2 ){
	ochan = 2 ;
	osr = 44100 ; 
	closeoutsound() ; 
    }


    sprintf( tempstring, "rm %s %s\0", ampname,  freqname );   
    system( tempstring ) ;   	
    
//    pri( mm, "NUMBER OF VALUES IN OUTPUT PITCH TRAJECTORY" ) ; 

    fprintf(stderr,"\n\nPITCHTRACKER : TRACKING COMPLETED\n");

    exit( 0 ) ;
}
usage(woof)
{
    fprintf(stderr, "%s",
	"pitchtracker:  pitch trajectory tracker\n"
	"pitchtracker [flags] [input file] [output  file (optional)]\n"
	"                    (16-bit shorts)     (default: envelope.out)\n"
	"	N:	FFT length (must be a power of 2) [1024]\n"
	"	M:	window size in samples (must be a power of 2) [2*FFT]\n"
	"		    (0 will automatically set window to 2*FFT size or larger)\n"
	"	D:	analysis frames per second [200]\n"

	"	b:	begin time in seconds  [0.] \n"
	"	e:	end time in seconds (-1. = end of file) [0.] \n"
	"	C:	analysis channel (1 -> ?) (0 = average of all) [0] \n"
	"	X:	multiple channel method: [0] \n"
	"		    0 = average,  1 = peak\n"

	"	m:	DETECTION METHOD: 0 = optimal comb,  1 = strongest frequency [0]\n"

	"	Q	DETECTION BAND: data type [0]\n"
	"		    0 = freq,  1 = octave.pitchclass\n"
	"	f:	DETECTION  BAND: lower freq/pitch boundary (func) [0]\n"
	"	F:	DETECTION  BAND: upper freq/pitch boundary (func) [Nyquist]\n"
	"	j:	DETECTION  WINDOW SIZE: BEGIN/MINIMUM (seconds) [.05]\n"
	"	J:	DETECTION  WINDOW SIZE: MAXIMUM (seconds) [.3]\n"
	"	d:	DETECTION  THRESHOLD:  (0 to -96 dB) [-40]\n"
	"	    COMPRESSOR/GATE\n"
	"	T:	compression threshold level in decibels (0 to -96) (func) [0]\n"
	"	G:	decibels of compression \n"
	"		    (0 to -96) (0 = no compression)(func) [0(off)]\n"
	"	S:	gate threshold level in decibels (0 to -96) (func) [-96 (off)]\n"
	"	l:      envelope attack time  (func) [0.]\n"
	"	L:      envelope release time   (func) [0.]\n"
	"	W:	distribution warp index (post compression) [0]\n"  
        "		    value of 0: no warp\n"
        "		    values > 0 warp the distribution downward\n"
        "		    values < 0 warp the distribution upward\n"

	"	p:	print elapsed time (1 = on,  0 = off) [0]\n"
	"	O:	OUTPUT FORMAT 0 = frequencies,  1 = octave.decimal\n"
	"		    2 = semitones of deviation above/below -o [0]\n"
	"		    3 = negative of semitones of deviation above/below -o [0]\n"
	"	o:	reference frequency for semitones of deviation [440]\n"
	"	r:	OUTPUT samples per second (interpolated) [500.]\n"
	"	g:	OUTPUT data type 0 = ascii,  1 = floats,  2 = shorts next soundfile [1]\n"
	"	a:	OUTPUT lowpass filter smoothing response time [0.]\n"
	);
    exit(woof);
}

float find_freq( channel, N, lo_freq, hi_freq, fundamental  )

    float   channel[];	// BIN FREQUENCIES AND AMPS

    int	    N ;	 

    float    lo_freq,		
	    hi_freq,
	    fundamental
	     ; 		


{

    int i,  peakbin,  not_done ; 
    float maxamp,  freqnow,  asum,  fsum ; 
    int lowi, hii ; 
    
    maxamp = 0. ; 
    freqnow = 0. ;
    peakbin = -1 ; 


    lowi = 2 * (int) (lo_freq / fundamental) ;  
    hii = 2 * (int) (hi_freq / fundamental) ;  
    if( lowi <= 0 ) lowi = 2 ; 
    if( hii <= lowi ) hii = lowi + 2 ; 
    if( hii >= N ) hii = N - 2 ; 
    lowi += 1 ; 
    hii += 1 ; 
    
    
    // FIND THE STRONGEST BIN
    for( i = lowi; i < hii; i += 2){
	if( channel[i - 1] > maxamp ){
	    maxamp = channel[i - 1] ;
	    freqnow = channel[i] ;
	    peakbin = i ; 
	}
    }

    if( peakbin != -1 ){
	// MAKE A WEIGHTED AVERAGE OF BINS AROUND peakbin
	asum = channel[peakbin -1] ; 
	fsum = channel[peakbin] * channel[peakbin -1] ; 
	
	// ABOVE
	i = peakbin + 2 ; not_done = 1 ;
	while( not_done ){
	    if( ((i > 0) && (i < N)) && 
		( (channel[i - 1] / channel[peakbin] ) > .031 ) ){
		    fsum += (channel[i] * channel[i - 1] ) ;
		    asum += channel[i - 1] ;
		    i += 2 ;   
	    }else{
		not_done = 0 ; 
	    }
	}

	// BELOW
	i = peakbin - 2 ; not_done = 1 ;
	while( not_done ){
	    if( ((i > 0) && (i < N)) && 
		( (channel[i - 1] / channel[peakbin] ) > .031 ) ){
		    fsum += (channel[i] * channel[i - 1] ) ;
		    asum += channel[i - 1] ;
		    i -= 2 ;   
	    }else{
		not_done = 0 ; 
	    }
	}

	// FIND WEIGHTED SUM VALUE
	if( asum > 0. )freqnow = fsum / asum ; 

    
    }    
    return( freqnow ) ;     


}







float find_common_freq( 

    float freqprop, 
    float fbuff[],  
    float abuff[], 
    int max_buffsize,  
    int begin_buffsize, 
    float ampthresh 
    
    ){
    float a1,  a2,  v1,  v2,  notefreq,  tfreqprop,  freqsum,  ampsum,  temp1 ; 
    int it,  n,  i, idex,  begin_buffsizesave,  zeroflag ; 
    
    begin_buffsizesave = begin_buffsize ; 
    notefreq = -1. ;
    tfreqprop = freqprop ;  
    zeroflag = 0 ; 
//pd(500);

//prf( ampthresh,  "ampthresh" ) ; 
	// TEST AMP BUFFER FOR ZERO AMP
	n = 0 ; 
	for( i = 0; i < max_buffsize; i++ )
	    if( abuff[i] > 0. ) n++ ; 
	if( n < begin_buffsize ){
	    // LEAVE
//prt( "ALL ZERO AMP" ) ; 
	    return( notefreq ) ; 
	}

	//* MAKE FREQUENCY*************
// notefreq: THE COMMON FREQ, SET TO -1 INITIALLY AS FLAG FOR NONE FOUND
// idex: THE BEGINNING INDEX POINT IN THE FREQ AND AMP BUFFERS
// begin_buffsize: THE BEGINNING BUFFER SIZE FROM WHICH TO FIND COMMON FREQ IN


		    while( notefreq == -1. ){
			// HAVEN'T FOUND A FREQ YET
			// SET THE INDEX TO THE BEGINNING OF THE BUFFER
			idex = 0 ;
			
			// IF STILL NO FREQUENCY AND BEGIN BUFF HAS NOT SHRUNK TO LESS THAN 6 
			while( (notefreq == -1.) && (begin_buffsize > 5) ){
			
//pd(501);

			    // * TEST FOR AMPLITUDE
			    ampsum = 0. ; 
			    for( i = idex; i < (idex + begin_buffsize) ; i++ ) ampsum += abuff[i] ; 
//pd(502);

			    if( ampsum != 0. ){
				// THERE IS AMPLITUDE
				// SET THE MINUMUM NUMBER OF VALUES FROM WHICH AN AVERAGE WILL 
				// BE MADE TO EQUAL A 1/4 OF THE BEGINNING BUFFER SIZE. 
				// SET zeroflag TO 1 TO SIGNAL AMP
				zeroflag = 1 ; 
				it = (float) begin_buffsize * .25 ; 
				
				// n IS THE COUNT ON THE VALUES FOUND COMMON ENOUGH TO USE
				// freqsum AND ampsum ARE THE SUM OF THE VALUES FOUND
				n = 0 ; freqsum = 0. ; ampsum = 0. ; 


				for( i = idex; i < (idex + (begin_buffsize / 2)) ; i++ ){
				    // i BEGINS AT idex AND MOVES HALFWAY THROUGH THE BEGINNING
				    // BUFFER SIZE
				
				    // MAKE A PROPORTION OUT OF VALUES LYING SYMETRICALLY IN
				    // THIS SHIFTIING BEGIN BUFF RANGE 
				    // IF THE END IS ZERO PREVENT THE DIVIDE (VALUE WILL NOT BE USED)
				    v1 = fbuff[i] ; v2 = fbuff[idex + begin_buffsize - i] ; 
				    a1 = abuff[i] ; a2 = abuff[idex + begin_buffsize - i] ;
//prf( a1,  "a1" ) ; 
//prf( a2,  "a2" ) ;
 				    
					//SKIP IF EITHER ARE BELOW THE AMP THRESHOLD
				    if( (a1 > ampthresh) && (a2 > ampthresh) ){
//prt( "INSIDE LOOKING" ) ; 				    
					if(v2 == 0.){
					    temp1 = fabs((double) (v1 / .001 )) ;
					}else{				
					    temp1 = fabs((double) (v1 / v2)) ;
					}

					//INVERT THE VALUE IF IT IS NOT A PROPORTION 
					if( temp1 > 1.) temp1 = 1./temp1 ; 

					//IF THE PROPORTION  IS ABOVE THE THRESHOLD,  THEN USE THE VALUES
					if( temp1 > tfreqprop){
					    // USE THEM
					    freqsum = freqsum +
						(a1 * v1) + (a2  * v2 );
					    ampsum += a1 + a2 ;
					    // ADD TO THE COUNT
					    n += 2 ; 
					}
				    
				    }
				}
//pd(504);
				// IF WE HAVE ENOUGH VALUES, THEN TAKE AN AVERAGE
				// NON -1 VALUE WILL TRIGGER RETURN
				if( n >= it ){
//prt( "ENOUGH VALUES TAKING AVERAGE...." ) ; 
				    // THIS WILL WORK: TAKE THE AVERAGE
					notefreq = freqsum / ampsum ;				 
				}
			    }
				
				// IF WE DID NOT GET A FREQUENCY CHANGE AND DO IT AGAIN
			    if( notefreq == -1. ){
				// THIS DOES NOT WORK
				// IF THE BUFFER BEGIN PT IS STILL AT THE BEGINNING (idex = 0 )
				// INCREASE THE BEGINNING BUFFER SIZE TOWARDS END OF FULL BUFFER
				// OTHERWISE SHRINK IT AWAY FROM BEGINNING, (THE END ON THE END)
				if( idex == 0 ){
				    // MAKE THE BUFFERSIZE LARGER
				    begin_buffsize++ ;
				    
				    // IF THE BUFFER HAS REACHED FULL SIZE
				    if(  begin_buffsize > max_buffsize){
					// TOO BIG: START SHRINKING TOWARDS END
					idex = 1 ; 
					// IF THE EXPANSION THROUGH THE FULL BUFFER DID NOT ONCE
					// PRODUCE A NON 0 AMP, THEN RETURN WITH -1 FREQ
					if( zeroflag == 0 ){
prt( "HERE! OH MY GOD!!!!" ) ; 

					    return( notefreq ) ; 
					}
					begin_buffsize = max_buffsize - idex ; 
				    }
				}else{
					// SHRINK MORE TOWARDS END
					idex++ ; begin_buffsize = max_buffsize - idex ; 
				}
			    }
//pd(505);

			  }
			  
			  // THIS HAS NOT WORKED. MAKE THE THRESHOLD MORE TOLERANT
			  tfreqprop *= tfreqprop ; 
//prf( tfreqprop,  "tfreqprop" ) ; 
			  // IF THE PROPORTION HAS FALLEN TOO LOW, TAKE AN AVERAGE AND LEAVE
			  if( tfreqprop < .75 ){
			      // MAKE SUM
			      freqsum = 0. ;
			      for( i = 0; i < max_buffsize ; i++ ){
				if(abuff[i] > ampthresh ) {
				    freqsum += fbuff[i] * abuff[i] ; 
				    ampsum = abuff[i] ;
				} 
			      }
			      // TAKE AVERAGE
			      if( ampsum > 0. )
				notefreq = freqsum / ampsum ;
			      else
				notefreq = -1 ;  
//prt( "SIMPLE AVERAGE" ) ; 

			      return( notefreq ) ; 
			  }

			  // RESET THE BUFFER TO THE BEGINNING SIZE
			  begin_buffsize = begin_buffsizesave ; 
		    }

	//* IT'S MADE*************

    return( notefreq ) ; 
//*************************************************

}



float sine_wave( float freq,  int R ){
    
    static float vlow, v,   vhi,  vfrac, fracdex,  sintab[ 2048 ], ftabdex=0.,  incr ; 
    static int tabsize=2048,  first=1,  ilowdex,  ihidex ; 
    int kt ; 
    
    if( first == 1 ){
	// MAKE TABLE
	first = 0 ; 
    //prt( "INITIIALIZING SINE TABLE" ) ; 
	for( kt = 0; kt < tabsize; kt++ ){
	    sintab[ kt ] = sin((double) (TWOPI * ( (float) kt / (float) tabsize ) ) ) ; 
	    //prf( sintab[ kt ],  "sintab" ) ; 
	}
    //prt( "TABLE DONE." ) ; 
    }
    
    // GET SINE VALUE
    // MAKE TABLE INCREMENT OUT OF FREQ
    incr = freq *  (float) tabsize / (float) R ; 
    ilowdex = (int) ftabdex ; 
    ihidex = ilowdex + 1; 
    if( ihidex == tabsize ) ihidex = 0 ; 
    //pri( ihidex, "ihidex" ) ;    
    fracdex = ftabdex - (float) ilowdex ; 

    vlow = sintab[ ilowdex ] ; 
    vhi =  sintab[ ihidex ]  ; 
    v = vlow + fracdex * (vhi - vlow) ; 
    
    ftabdex = ftabdex + incr ; 
    while( ftabdex >= (float) tabsize ) ftabdex = ftabdex - (float) tabsize ; 
    return( v ) ; 
}

int pd( i ) int i ; { fprintf( stderr, "\n PRINT DEBUG POINT # %d ", i ) ; }


float norm_value( 
    float avalue,  
    float peakenvamp, 
    float compression, 
    float ampthresh, 
    float ampgatethresh, 
    float warp   
    ){ 

    float temp3 ;
    static float shortnorm ; 
    
    shortnorm = 1. - (1./32760.) ;   
    
// NORMALIZE 
	    avalue = avalue / peakenvamp ; 

//prf( avalue, "avalue in norm_value" ) ; 

// AMP COMPRESSION
// TEST WHETHER ABOVE THRESHOLD
	    if( avalue > ampthresh ){
		avalue = (ampthresh + ((avalue - ampthresh) * compression)) ; 
	    }
// GATE
	    if( avalue > ampgatethresh ){
		// ABOVE GATE LOWER BY GATE AMP AMOUNT
		avalue = avalue - ampgatethresh ; 
	    }else{
		// BELOW GATE THRESHOLD, GATE IT
		avalue = 0 ; 
	    }
	    
	    // USING THE COMPRESSION AND GATE STUFF, NORMALIZE IT BACK TO THE ORIGINAL RANGE
	    temp3 = 1. /  ((ampthresh  + ((1. - ampthresh) * compression) ) - ampgatethresh) ;
	    avalue = avalue * temp3 *  shortnorm ; 

// WARP THE RESULTING SIGNAL
	    avalue = curve( 0.,  1.,  avalue,  warp  ) ;


 
    return( avalue ) ; 
 
 }
 




 int zero_cross_peaks( float F[], float F_i[],   int N,  
	    int formant_bin[],  int NP,  int num_formants  
	    ){
    
    // TAKE SUCCESSIVE DIFFERENCES TO PLACE PEAKS AT ZERO CROSSINGS
    int i, j,  sign,  p,  breakout,  doneflag, peak_count,  PV ;
    int num_to_avg,  save_i, start_i,  k,  Nm,  addflag ; 
    float mult, mprop,  temp,  sum,  peak,  minamp,  
	min_formant_dB, dB_adder,  min_formant_amp ;  	    
    static int first=0;
    static float  *temp_F_i ; 
    
    doneflag = 0 ; 
    min_formant_dB = -3 ; 
     dB_adder = 10 ; 
     addflag = 0 ; 
     
    // COPY F INTO F_i, FINDING PEAK
    // ZER0 OUT DC 
    peak = -999999. ; 
    for( i = 2 ; i < N ; i += 2 ){
	    // CHECK FOR PEAK
	   if( F[ i ] > peak ) peak = F[ i ] ;  
	   // MAKE ARRAY OF DIFFERENCES IN WHICH PEAKS AND VALLEYS ARE ZERO, AND
	   // POSITVE VALUES ARE ASCENT TO PEAK, AND NEGATIVE ARE DESCENT TO VALLEY.  
	   F_i[ i - 2 ] = F[ i ] -  F[ i - 2 ] ; // CHANGE FROM VALUE
	   F_i[ i - 1 ] = F[ i - 1 ]  ; //TRANSFER FREQ
    }

    // "peak" IS THE AMPLITUDE OF THE PEAK
    
    F_i[ N - 2 ] = 0 ; F_i[ N - 1 ] = F[ N - 1 ] ;

    while( doneflag == 0 ){
	
	// CREATE THE MINIMUM FORMANT AMP (FROM dB) RELATIVE TO THE PEAK
	minamp = peak * dB_to_amp( min_formant_dB ) ; 

	sign = 1 ; p = 0 ; breakout = 0 ;

      // ANALYZE FOR ZERO CROSSINGS

      // SAVE FIRST  VALLEY BIN AS DC BIN (0)
      formant_bin[ p ] = 0 ;  PV = 1 ; 

    i = 2; j = 1; peak_count = 0 ; 
     
    while( (i < N) ){
	    if( (sign >= 0.) ){
		// WAS ASCENDING
		if(  F_i[ i ] >= 0. ){
		    // STILL ASCENDING
		}else{
		    // NOW DESCENDING: ARE WE ABOVE THE AMP THRESHOLD, THEN

		    if(  F[ i ] > minamp ){ 

			// CHANGE SIGN
			// HIT PEAK: SAVE BIN LOCATION AND INCREMENT COUNT

 
			sign = -1 ;
			peak_count++ ; 
			if( p >= (NP - 1) ) {
			    breakout = 1 ; 
			} 
			else{
			    p++ ;  
			    formant_bin[ p ] = j ; PV = 0 ; 
			}
		    }  
		}
	    }else{
		// WAS DESCENDING
		if(  F_i[ i ] < 0. ){
		    // STILL DESCENDING
		}else{
		    // NOW ASCENDING: CHANGE SIGN
		    // HIT VALLEY: SAVE BIN LOCATION AND INCREMENT COUNT
		    sign = 1 ;
		    if( p >= (NP - 1)  ) {
			breakout = 1 ; 
		    } 
		    else{
			p++ ;  formant_bin[ p ] = j ; PV = 1 ; 
		    } 
		    
		}
		
	    }
	i += 2 ; j++ ; 
      }




	peak_count = p / 2 ; 

     if( (peak_count == num_formants) 
	    || (dB_adder < 1. )
	    || (min_formant_dB < MINUMUM_FORMANT_DB )  ){

	 // EITHER WE HAVE MATCHED OR CONVERGED TO DEATH: EXIT

	    if((p - ( ( p / 2 ) * 2 )) == 0 ){
		// OK,REPLACE THE  TOP  VALLEY WITH THE TOP BIN
		formant_bin[ p ] = (N / 2) - 1 ;
	    }else{
		//INCREMENT TO THE TOP VALLEYLESS PEAK AND ADD TOP BIN AS TOP VALLEY
		p++ ; formant_bin[ p ] = (N / 2) - 1 ; 
	    }

	    return( peak_count ) ; 

     }else if( peak_count < num_formants  ){
	    // TOO FEW PEAKS:  LOWER dB THRESHOLD AND SEARCH AGAIN
	    if( addflag == 1 ) dB_adder = 2. * dB_adder / 3. ;
	    min_formant_dB -= dB_adder ; 
	    addflag = -1 ; 
	    doneflag = 0 ; 

      }else{
	// TOO MANY PEAKS: RAISE dB THRESHOLD AND SEARCH AGAIN
	    if( addflag == -1 ) dB_adder = 2. * dB_adder / 3. ;
	    min_formant_dB += dB_adder ; 
	    addflag = 1 ; 
	    doneflag = 0 ; 

      }


    }	

		
  }
  
  
    
int print_peak_freqs( float F[], float fundamental,  int N,  int formant_bin[], int num_peaks ){
    
    // PRINT THE PEAK FREQUENCIES
	int i, j, k ; 
	float oldfreq = 0,  diff, dB,    diffsum ; 

    diffsum = 0. ; 
/*
 * formant_bin CONTAINS THE NUMBER OF THE BINS (AMP/FREQ PAIRS) WHICH REPRESENT
 * THE VALLEYS AND PEAKS. THEY ARE ARRANGED: VALLEY PEAK VALLEY PEAK... VALLEY (extra on top)
 * 
 */

	fprintf( stderr, "\n*** PEAK FREQUENCIES ****" ) ; 
		oldfreq = F[(2 * formant_bin[ (0 * 2) + 1 ]) + 1] ; 
	for( i = 0; i <	num_peaks; i++){
	    diff = F[(2 * formant_bin[ (i * 2) + 1 ]) + 1] - oldfreq ; 
	    dB = (20. * log10( (double)  F[ 2 * formant_bin[ (i * 2) + 1 ] ] )) ; 

	    diffsum += diff ; 
	    fprintf( stderr, "\n %d) VALLEY BIN: %d,  VALLEY:%6.2f, PEAK BIN: %d,  PEAK:%6.2f, PEAKDB: %6.2f,  DIFF: %f  ",  
		i+1, formant_bin[ (i * 2)  ], F[(2 * formant_bin[ (i * 2)  ]) + 1] , 
		 formant_bin[ (i * 2) + 1 ],  F[(2 * formant_bin[ (i * 2) + 1 ]) + 1], 
		dB, diff ) ; 

	    oldfreq = F[(2 * formant_bin[ (i * 2) + 1 ]) + 1] ; 
	}

    fprintf( stderr, "\ndiff freq: %f",  (diffsum/(float) num_peaks) ) ; 

    return(1) ; 

}

int find_formants( 
    float F[], 
    float fundamental,  
    int N,  
    int formant_bin[], 
    int num_peaks, 
    float formant_freq[], 
    float formant_amp[], 
    int formant_freq_rank[]
     ){
    
    // COMPUTE THE FORMANT CENTER FREQUENCIES USING THE BINS BETWEEN THE VALLEYS.
    //AVERAGE THEIR FREQS WEIGHTED BY THE SQUARE OF THEIR AMPS


    // SORT THEM VIA formant_freq_rank 

/*
 * formant_bin CONTAINS THE NUMBER OF THE BINS (AMP/FREQ PAIRS) WHICH REPRESENT
 * THE VALLEYS AND PEAKS. THEY ARE ARRANGED: VALLEY PEAK VALLEY PEAK... VALLEY (extra on top)
 * 
 */

	int i, j, k,  again ;
	float temp,  diffsum,  oldfreq ;  

	
	for( i = 0; i <	num_peaks; i++){
		
	    formant_freq[ i ] = 
		 F[(2 * formant_bin[ (i * 2) + 1 ]) + 1] ; 
	    formant_amp[ i ] = 
		 F[(2 * formant_bin[ (i * 2) + 1 ])] ; 

	}


	for( i = 0; i <	num_peaks; i++)
		formant_freq_rank[ i ] = i ; 

	// SORT
	again = 1 ; 
	
	while( again ){
	    // SORT AGAIN
	    again = 0 ; 
	    for( i = 1; i <	num_peaks; i++){
		// COMPARE
		if( formant_amp[ formant_freq_rank[ i ] ] > 
			formant_amp[formant_freq_rank[ i - 1 ]] ){
		    // SWITCH RANKING
		    k = formant_freq_rank[i - 1] ; 
		    formant_freq_rank[i - 1] = formant_freq_rank[i] ;
		    formant_freq_rank[i] = k ;
		    // DO IT AGAIN
		    again = 1 ; 
		} 
	    }
	    
	}

/*
prline( 69,   "=" ) ; 
	for( i = 0; i <	num_peaks; i++){
	    k = formant_freq_rank[i] ; 
	    fprintf( stderr,  "\n%d: FREQ: %f,  DB: %f",  
			i,  formant_freq[k],  amp_to_dB( formant_amp[k] ) ); 
	}
*/

	diffsum = 0. ; oldfreq = formant_freq[ 0 ]  ; 
	for( i = 1; i <	(num_peaks - 3); i++){
	    diffsum += (formant_freq[ i ] - oldfreq ) ; 
	    oldfreq = formant_freq[ i ] ; 
	}    
	 

    return(1) ; 
}


 

float find_freq_new( 
    
    int detect_method,
    float  lowf, 
    float hif,
    float formant_freq[], 
    float  formant_amp[],
    int formant_freq_rank[], 
    int num_peaks 
    
){

    float freq,  temp ; 
    int i,  j,  k ; 
    
    freq = -1. ; 

    if( detect_method == 0 ){    


	// USE OPTIMAL COMB METHOD ON FORMANTS
	
	static int first=1 ; 
	static float *sums ; 
	int i, j, k ; 
	float temp,  temp2 ; 
	
	if( first){
	    fvec( sums, num_peaks ) ; 
	    first = 0 ; 
	}
	
	for( i = 0; i < num_peaks; i++ ){
	    // MAKE SUM FOR EACH FORMANT
	    
	    sums[ i ] = 0. ; 
	    for( k = i; k < num_peaks ; k++){
		temp = formant_freq[ k ] / formant_freq[ i ] ; 
		temp = (2. * (temp - (float) ( (int) temp ))) - 1.  ; // -1 to 1
		if( temp < 0. ) temp *= -1. ; 
		sums[ i ] += temp ; 

	    }
	
	}    

//	for( i = 0; i < num_peaks ; i++)
//	    fprintf( stderr, "\n%d: FREQ: %f, SUM: %f",  i, formant_freq[ i ],   sums[ i ] ) ; 

 
	// FIND OUT WHICH ONE IS THE STRONGEST
	k = 0 ; 
	for( i = 1; i < num_peaks ; i++){
	    if( sums[ i ] > sums[k] ) k = i ; 
	}

    
	freq = formant_freq[ k ] ; 

    }else{
	// STRONGEST FREQ
		
	for( i = 0; i < num_peaks ; i++){
	    
	    temp = formant_freq[ formant_freq_rank[ i ] ] ; 

	    if( (temp >= lowf) && (temp <= hif ) ) freq = temp ; 
	    
	    if( freq != -1. ) break ; 

	}
	
	


    }

    return( freq ) ; 

} 

