#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "globals.h"

#define SND_FORMAT_LINEAR_16            (3)

#define BLOCKSIZE 8192

/*
* THIS ROUTINE READS THE SHORTS OF THE SPECIFIED FILE AND 
* CHANNEL AND WRITES THEM AS FLOATS TO THE STANDARD OUT
*
*/

/* CRACK STUFF */
extern int arg_index;
extern char *arg_option;
extern int bannerflag;


/************************************************************/

int main(argc,argv)
   int argc;
   char *argv[]; 
   {
   


    char	*filename, 
		ch, 
		crack()
    ;

    int		pflag=0, 
		outputswitch=1, 
		i, 
		n, 
		doneflag=0, 
		numsamps,
		numbytes,  
		exflag, 
		sr,
		chan,
		data_offset, 
		format, 
		fd,
		end_sample, 
		begin_sample, 
		sample, 
		outchan=0, 
		peak_samp_time[16]
    ;
    int channow,  beginchan,  endchan,  exitflag ; 	    
	
    short int	idata[ BLOCKSIZE * 4 ] 
    ; 
    float	fdata[ BLOCKSIZE * 4 ] 
    ; 
		
    float	sampnow,
		peakamp[16],
		peakdB[16],
		rms[16], 
		rmsdB[16],
		DC[16],    
		c,
		avgamp[16],
		avgdB[16],   
		dur, 
		out, 
		begin, 
		end,
		endsave=-1., 
		temp
    ;

	FILE *data_file ;


#include "underflow.h"


/*GIVE USAGE AND EXIT IF NO ARGUMENTS */
   if(argc == 1) {
	fprintf( stderr,"%s",
	"USAGE:\n\n   rms [ flags ] [ NeXT/Sun format input soundfiles (integer or floats)]\n" 
	"\tflags:\n"
	"	(values in brackets denote defaults)\n"
	"   :c	    channel: 1 to ?,  0 = all [0]\n"
	"   :b	    start time in seconds [0.]\n"
	"   :e	    end time [end of file]\n\n"
	"   For each of the NeXT/Sun format integer or float files,\n"
	"   this routine reads the specified channel(s) for the values \n"
	"   between begin and end, printing peak amplitude, average  \n"
	"    peak amplitude, RMS amplitude and average DC amplitude.\n\n" 
	 );
	exit(0);
    }
   
begin = 0. ; outchan = 0 ; 

    while((ch = crack(argc,argv,"c|b|e|po",0)) != 0)
{
        switch(ch) {
            case 'c': outchan = atoi(arg_option) ;                  break;
            case 'b': begin = atof(arg_option) ;                  break;
            case 'e': endsave = atof(arg_option) ;                  break;

        }
    }

    if( arg_index >= argc ){
	    //banner() ;
	fprintf( stderr, "\n\nWHERE IS THE FILE? BYE.\n\n") ;
        exit(0)  ;	
    }


while( arg_index < argc ){
   end = endsave ; exitflag = 0 ;  doneflag = 0 ; 


/* GET SOUNDFILE NAME AND OPEN FOR BUSINESS */
   filename = argv[arg_index] ;

        exflag = getsfstats(filename, &sr, &chan, &dur, \
                &data_offset, &format);
	
	fprintf( stderr, "\n------------------------------------------------------------" ) ; 
	fprintf( stderr, "\nFILENAME:\t%s",  filename ) ; 
	fprintf( stderr, "\n%d CHANNELS",  chan ) ; 
	fprintf( stderr, "\n============================================================" ) ; 

	if ( exflag == -2 ) {
	    //banner() ;
	    fprintf( stderr, "\n\n\t....FIX THE FORMAT OF YOUR FILE. BYE.\n\n" ) ;
	    exitflag = 1 ;  
	}
	if( exitflag == 0 ) if( exflag == -1 ) {
	    //banner() ;
	    fprintf( stderr, "\n\n\t....FIX YOUR FILE (PATH)NAME. BYE.\n\n" ) ;
	    exitflag = 1 ;  
	}


	begin_sample = begin * (float) sr ; 

		 

	if( exitflag == 0 ) if( exflag  == -1 ) 

/* CHECK FOR STUPIDITY */
	    if( (format != 3) || (format != 6)  ){
		//banner() ;
		fprintf( stderr, "\n\nYOUR FILE IS NOT A FLOAT OR INTEGER FORMAT NEXT FILE.\n\n" ) ;
		exitflag = 1 ;  
	    }

    if( exitflag == 0 ) if( begin < 0. ){
	fprintf( stderr,
	     "\n\nBEGIN TIME (%f) is < 0. (GET REAL!)\nWILL RESET TO 0.\n\n",  begin  ) ;
	     begin = 0. ; 
    }

	
    if( exitflag == 0 ) if( (end != -1.) && (end <= begin)){


	    //banner() ;
	fprintf( stderr,
	     "\n\nBEGIN TIME = %f\nEND TIME = %f\n\n",  begin,  end  ) ;

	fprintf( stderr,
	     "\n\nYOUR END TIME IS BEFORE OR EQUAL TO YOUR BEGIN TIME! BYE.\n\n" ) ;
	exit(0) ; 
    }
	
    if( exitflag == 0 ) if( end > dur ){
	    //banner() ;
	    fprintf( stderr, "%s%f%s%f%s", "\nYOUR END TIME OF  ", 
		end, 
		"  SECONDS \nEXCEEDS THE FILE DURATION OF  ", 
		dur, 
		" SECONDS.\nWILL RESET TO THE DURATION OF THE FILE.\n\n" 
		 ) ;
	    end = dur ; 	   	

    }

/* ZERO STUFF */
for( i = 0; i < 16; i++){
    peakamp[i] = 0.; avgamp[i] = 0.; rms[i] = 0 ; DC[i] = 0. ; 
}
  
/* NO END TIME SPECIFIED, SET TO dur */
    if( end <= 0. ) end = dur ; 
    end_sample = (int) (end * (float) sr ) ; 
 
 
 
    if( exitflag == 0 ) if( outchan >= chan ){
	//banner(); 
        fprintf( stderr, "\n\nTHE AVAILABLE CHANNELS ARE 0-%d, NOT %d. BYE.\n\n",\
	     (chan-1), outchan ) ;
	    exitflag = 1 ;  
   }

    /* SETUP CHANNEL STUFF */
    if( outchan == 0 ){
	beginchan = 0; endchan = chan - 1 ; 
    }else{
	beginchan = outchan - 1; endchan = beginchan ; 
    }


if( exitflag == 0 ){ 


    data_file = fopen( filename,  "r" ) ; 

/* SKIP TO DATA OFFSET + BEGIN */
	
	fseek( data_file, data_offset + (2 * begin_sample * chan), SEEK_SET ) ;
	
/* READ IN THE VALUES */


	c = 0 ;  sample = begin_sample ; 

	if( format == SND_FORMAT_LINEAR_16 )
	    numsamps = fread( &idata, sizeof(short int), BLOCKSIZE,  data_file ) ; 
	else
	    numsamps = fread( &fdata, sizeof(float), BLOCKSIZE,  data_file ) ; 
		
	numsamps = numsamps / chan ; 
	
	while( (doneflag != 1 ) && ( numsamps > 0 ) ) {

	    if( (end_sample - sample) < numsamps ){
		numsamps = (end_sample - sample) ;
		doneflag = 1 ;  
	    }

	    for( i = 0; i < numsamps; i++ ){


		for( channow = beginchan; channow <= endchan; channow++){

		    if( format == SND_FORMAT_LINEAR_16 )
			sampnow = ((float) idata[ (i * chan) + channow ]) / 32768.0 ; 
		    else
			sampnow = fdata[ (i * chan) + channow ] ; 
		    
		    
		    
		    
		    // PEAK AMP
		    temp = fabs( sampnow ) ; 
		    if( temp > peakamp[ channow ] ){
			peakamp[ channow ] = temp ; peak_samp_time[ channow ]  = c ; 
		    } 

		    // AVERAGE AMP
		    avgamp[ channow ] += temp ;
		
		    // RMS
		    rms[ channow ] = rms[ channow ] + (sampnow * sampnow) ; 

		    // DC AVERAGE
		    DC[ channow ] += sampnow ; 
		    

		}

		c += 1. ; 
	    }

	    sample += numsamps ; 

	if( format == SND_FORMAT_LINEAR_16 )
	    numsamps = fread( &idata, sizeof(short int), BLOCKSIZE,  data_file ) ; 
	else
	    numsamps = fread( &fdata, sizeof(float), BLOCKSIZE,  data_file ) ; 



	numsamps = numsamps / chan ; 
	
	}

	fclose( data_file ) ; 

	fprintf( stderr, "\nFILE DURATION:\t\t%f",  dur ) ; 
	fprintf( stderr, "\nSEGMENT DURATION:\t%f (%f to %f)",  end - begin,  begin,  end ) ; 

	for( channow = beginchan; channow <= endchan; channow++){


	fprintf( stderr, "\n------------------------ CHANNEL %d -------------------------",   channow + 1 ) ; 

	    DC[ channow ] =  DC[ channow ] / c ; 
	    temp =  (float) (20. * log10( (double) fabs( DC[ channow ] )) ) ; 
	    fprintf( stderr, "\nAVG. DC AMP:\t%8.5f\t   (%6.2f dB)", DC[ channow ],  temp ) ;

	fprintf( stderr, "\n                                                TIME" ) ; 

	    temp = (float) (20. * log10( (double) peakamp[ channow ] )) ; 
	    fprintf( stderr, "\nPEAKAMP:\t%8.5f\t   (%6.2f dB)\t%f sec",
		 peakamp[ channow ],  temp,  begin + ((float) peak_samp_time[ channow ] / (float) sr ) ) ;

	    avgamp[ channow ] = avgamp[ channow ] /  c ;
	    temp = (float) (20. * log10( (double) avgamp[ channow ] )) ; 
    	    fprintf( stderr, "\nAVG. PEAK AMP:\t%8.5f\t   (%6.2f dB)",  avgamp[ channow ],  temp ) ;


	    rms[ channow ] = (float) pow( (double) (rms[ channow ] / c),  .5 ) ; 
	    temp = (float) (20. * log10( (double) rms[ channow ] )) ; 
    	    fprintf( stderr, "\nRMS AMP:\t%8.5f\t   (%6.2f dB)",  rms[ channow ],  temp ) ;
	}

	fprintf( stderr, "\n============================================================\n" ) ; 




/*

*/

}
    arg_index++ ; 
}
    exit( 1 ) ; 
}


int banner(){
    if( bannerflag == 0 )
    fprintf( stderr,  "\n\n*************************************\n*********     RMS     **********\n*************************************\n" ) ;
			 bannerflag = 1 ; 
}	


